import java.io.InputStream;
import java.io.DataInputStream;
public class Loader {
public Mesh load(String s,int scaling){
try{
return load(getClass().getResourceAsStream(s),scaling);
}catch(Exception e){return new Mesh();}
}
public Mesh load(InputStream is,int scaling){
Mesh m=new Mesh();
try{
DataInputStream d=new DataInputStream(is);
int numFaces=d.readInt();
for(int i=0;i<numFaces;i++){
int type=d.readInt();
switch(type){
case 0: readTriangle(d,m,scaling);break;
case 1: readSquare(d,m,scaling);break;
case 2: readCircle(d,m,scaling);break;
case 3: readLine(d,m,scaling);break;
}
}
d.close();
is.close();
}catch(Exception e){}
return m;
}
public void readTriangle(DataInputStream d,Mesh m,int s){
try{
Triangle f=new Triangle(nv(d,s),nv(d,s),nv(d,s),d.readInt());
m.addFace(f);
}catch(Exception e){}
}
public void readSquare(DataInputStream d,Mesh m,int s){
try{
Square sq=new Square(nv(d,s),nv(d,s),nv(d,s),nv(d,s),d.readInt());
m.addFace(sq);
}catch(Exception e){}
}
public void readCircle(DataInputStream d,Mesh m,int s){
try{
Circle c=new Circle(nv(d,s),nv(d,s),d.readInt());
m.addFace(c);
}catch(Exception e){}
}
public void readLine(DataInputStream d,Mesh m,int s){
try{
Line l=new Line(nv(d,s),nv(d,s),d.readInt());
m.addFace(l);
}catch(Exception e){}
}
public Vertex nv(DataInputStream d,int s){
try{
return new Vertex(d.readInt()*s,d.readInt()*s,d.readInt()*s);
}catch(Exception e){return null;}
}
}