/*
 * Класс для создания основных трехмерных фигур. Плоскость, куб, рамка-куба, тор, сфера, пирамида, диск, цилиндр и конус =)
 */

public class Create
{
  public static Face[] plane(Vertex m, Vertex n, int color)
  {
      Vertex a=new Vertex(m), b=new Vertex(n);
      if(m.x>n.x){
          a.x=n.x;
          b.x=m.x;
      }else{
          a.x=m.x;
          b.x=n.x;
      }
      if(m.z>=n.z){
          a.z=m.z;
          b.z=n.z;
      }else{
          a.z=n.z;
          b.z=m.z;
      }
    Triangle[] v = new Triangle[2];
    Vertex v1 = new Vertex(a);
    v1.setUV(0,0);
    Vertex v2 = new Vertex(a.x, a.y, b.z);
    v2.setUV(0, 1);
    Vertex v3 = new Vertex(b.x, a.y, a.z);
    v3.setUV(1, 0);
    Vertex v4 = new Vertex(b.x, a.y, b.z);
    v4.setUV(1, 1);
    v[0] = new Triangle(v1, v2, v3, color);
     v[0].norm(0,1,0);
     v[0].setUV();
    // v[0].setUV(new float[]{0,0,0,1,1,0});
    v[1] = new Triangle(v3, v2, v4, color);
     v[1].norm(0,1,0);
     v[1].setUV();
   //  v[1].setUV(new float[]{1,0,0,1,1,1});
    return v; }

  public static Face[] box(Vertex m, Vertex n, int color) {
      Vertex a=new Vertex(),b=new Vertex();
      if(m.x>n.x){a.x=n.x;b.x=m.x;}
      else{a.x=m.x;b.x=n.x;}
      if(m.y>n.y){a.y=n.y;b.y=m.y;}
      else{a.y=m.y;b.y=n.y;}
      if(m.z>n.z){a.z=n.z;b.z=m.z;}
      else{a.z=m.z;b.z=n.z;}
    Triangle[] t = new Triangle[12];
    Vertex[] v = new Vertex[8];
    v[0] = new Vertex(a);
    v[1] = new Vertex(a.x, b.y, a.z);
    v[2] = new Vertex(b.x, b.y, a.z);
    v[3] = new Vertex(b.x, a.y, a.z);
    v[4] = new Vertex(a.x, a.y, b.z);
    v[5] = new Vertex(a.x, b.y, b.z);
    v[6] = new Vertex(b);
    v[7] = new Vertex(b.x, a.y, b.z);

    t[0] = new Triangle(v[0], v[1], v[2], color);
    t[0].norm(0, 0, -1);
    t[0].smooth=false;
    t[0].setUV(new float[]{0,1,0,0,1,0});
    t[1] = new Triangle(v[2], v[3], v[0], color);
    t[1].norm(0, 0, -1);
    t[1].smooth=false;
    t[1].setUV(new float[]{1,0,1,1,0,1});

    t[2] = new Triangle(v[0], v[1], v[5], color);
    t[2].norm(-1, 0, 0);
    t[2].smooth=false;
    t[2].setUV(new float[]{1,1,1,0,0,0});
    t[3] = new Triangle(v[5], v[4], v[0], color);
    t[3].norm(-1, 0, 0);
    t[3].smooth=false;
    t[3].setUV(new float[]{0,0,0,1,1,1});

    t[4] = new Triangle(v[3], v[2], v[6], color);
    t[4].norm(1,0,0);
    t[4].smooth=false;
    t[4].setUV(new float[]{0,1,0,0,1,0});
    t[5] = new Triangle(v[6], v[7], v[3], color);
    t[5].norm(1,0,0);
    t[5].smooth=false;
    t[5].setUV(new float[]{1,0,1,1,0,1});

    t[6] = new Triangle(v[1], v[5], v[6], color);
    t[6].norm(0,1,0);
    t[6].smooth=false;
    t[6].setUV(new float[]{0,1,0,0,1,0});
    t[7] = new Triangle(v[6], v[2], v[1], color);
    t[7].norm(0,1,0);
    t[7].smooth=false;
    t[7].setUV(new float[]{1,0,1,1,0,1});

    t[8] = new Triangle(v[0], v[4], v[7], color);
    t[8].norm(0,-1,0);
    t[8].smooth=false;
    t[8].setUV(new float[]{0,0,0,1,1,1});
    t[9] = new Triangle(v[7], v[3], v[0], color);
    t[9].norm(0,-1,0);
    t[9].smooth=false;
    t[9].setUV(new float[]{1,1,1,0,0,0});

    t[10] = new Triangle(v[4], v[5], v[6], color);
    t[10].norm(0,0,1);
    t[10].smooth=false;
    t[10].setUV(new float[]{1,1,1,0,0,0});
    t[11] = new Triangle(v[6], v[7], v[4], color);
    t[11].norm(0,0,1);
    t[11].smooth=false;
    t[11].setUV(new float[]{0,0,0,1,1,1});
    return t; }
  
  public static Face[] wireBox(Vertex a,Vertex b,int color){
      Line[] l=new Line[12];
      Vertex[] v=new Vertex[8];
    v[0] = new Vertex(a);
    v[1] = new Vertex(a.x, b.y, a.z);
    v[2] = new Vertex(b.x, b.y, a.z);
    v[3] = new Vertex(b.x, a.y, a.z);
    v[4] = new Vertex(a.x, a.y, b.z);
    v[5] = new Vertex(a.x, b.y, b.z);
    v[6] = new Vertex(b);
    v[7] = new Vertex(b.x, a.y, b.z);
    l[0]=new Line(v[0],v[3],color);
    l[1]=new Line(v[0],v[1],color);
    l[2]=new Line(v[1],v[2],color);
    l[3]=new Line(v[2],v[3],color);
    l[4]=new Line(v[0],v[4],color);
    l[5]=new Line(v[1],v[5],color);
    l[6]=new Line(v[2],v[6],color);
    l[7]=new Line(v[3],v[7],color);
    l[8]=new Line(v[4],v[5],color);
    l[9]=new Line(v[5],v[6],color);
    l[10]=new Line(v[6],v[7],color);
    l[11]=new Line(v[4],v[7],color);
      return l;
  }

  public static Face[] torus(Vertex c, int R1, int R2, int SEGS1, int SEGS2, int color) {
    int j;
    int n = 0;

    if ((SEGS1 < 2) || (SEGS2 < 2)) return null;
    int numVerts = 0;
    int numFaces = 0;

    Vertex[] verts = new Vertex[SEGS1 * SEGS2];
    Triangle[] faces = new Triangle[SEGS1 * SEGS2 * 2];
    for (int i = 0; i < SEGS1; ++i)
      for (j = 0; j < SEGS2; ++j) {
        verts[numVerts] = new Vertex();
        float a1 = i * 6.2831854820251465F / SEGS1;
        float a2 = j * 6.2831854820251465F / SEGS2;
        int cx = (int)((R1 + R2 * Math.cos(a2)) * Math.cos(a1));
        int cz = (int)((R1 + R2 * Math.cos(a2)) * Math.sin(a1));
        int cy = (int)(R2 * Math.sin(a2));
        verts[numVerts].u = 1024 * i / SEGS1;
        verts[numVerts].u/=1024;
        verts[numVerts].v = 256 * j / SEGS2;
        verts[numVerts].v/=256;
        verts[numVerts].x = (cx + c.x);
        verts[numVerts].y = (cy + c.y);
        verts[numVerts].z = (cz + c.z);
        ++numVerts;
      }

    for (int i = 0; i < SEGS1; ++i) {
      for (j = 0; j < SEGS2; ++j) {
        faces[numFaces] = new Triangle(nv(), nv(), nv(), color);
        faces[numFaces].a = verts[(n + j)];
        faces[numFaces].b = verts[((n + (j + 1) % SEGS2) % numVerts)];
        faces[numFaces].c = verts[((n + (j + 1) % SEGS2 + SEGS2) % numVerts)];
        faces[numFaces].norm();
        faces[numFaces].setUV(new float[]{faces[numFaces].a.u,faces[numFaces].a.v,faces[numFaces].b.u,faces[numFaces].b.v,faces[numFaces].c.u,faces[numFaces].c.v});

        numFaces++;
        faces[numFaces] = new Triangle(nv(), nv(), nv(), color);
        faces[numFaces].a = verts[((n + (j + 1) % SEGS2 + SEGS2) % numVerts)];
        faces[numFaces].b = verts[((n + j + SEGS2) % numVerts)];
        faces[numFaces].c = verts[(n + j)];
        faces[numFaces].norm();
        faces[numFaces].setUV(new float[]{faces[numFaces].a.u,faces[numFaces].a.v,faces[numFaces].b.u,faces[numFaces].b.v,faces[numFaces].c.u,faces[numFaces].c.v});

        numFaces++;
      }
      n += SEGS2;
    }
    return faces; }

  static Vertex nv() {
    return new Vertex(); }

  public static Face[] pyramid(Vertex c, Vertex c2, int h, int color) {
    Triangle[] t = new Triangle[6];
    Vertex[] v = new Vertex[5];
    if(c2.x<c.x) c2.x=c.x+(c.x-c2.x);
    if(c2.z>c.z) c2.z=c.z-(c2.z-c.z);
    v[0] = new Vertex(c.x, c.y + h, c.z);
    v[1] = new Vertex(c2);
    int cx = c.x - c2.x + c.x; int cz = c.z + c.z - c2.z;
    v[2] = new Vertex(cx, c.y, c2.z);
    v[3] = new Vertex(cx, c.y, cz);
    v[4] = new Vertex(c2.x, c.y, cz);
    t[0] = new Triangle(v[1], v[2], v[3], color);
    t[0].norm();
    t[0].smooth=false;
    t[0].setUV(new float[]{1,0,0,0,0,1});
    t[1] = new Triangle(v[3], v[4], v[1], color);
    t[1].norm();
    t[1].smooth=false;
    t[1].setUV(new float[]{0,1,1,1,1,0});
    if(h>0){t[0].invert();t[1].invert();}
    t[2] = new Triangle(v[2], v[0], v[1], color);
    t[2].norm();
    t[2].smooth=false;
    t[2].setUV(new float[]{0,1,0.5F,0,1,1});
    t[3] = new Triangle(v[2], v[0], v[3], color);
    t[3].norm();
    t[3].smooth=false;
    t[3].setUV(new float[]{1,1,0.5F,0,0,1});
    t[4] = new Triangle(v[1], v[0], v[4], color);
    t[4].norm();
    t[4].smooth=false;
    t[4].setUV(new float[]{0,1,0.5F,0,1,1});
    t[5] = new Triangle(v[3], v[0], v[4], color);
    t[5].norm();
    t[5].smooth=false;
    t[5].setUV(new float[]{1,1,0.5F,0,0,1});
    if(h>0){t[3].invert();t[5].invert();}else{t[2].invert();t[4].invert();}
    return t;
  }
  
  public static Face[] disk(Vertex c,double r,int slices,int color){
      double angle = 6.2831853071795862D / (double)slices;
      Triangle[] t=new Triangle[slices];
      Vertex[] vx=new Vertex[slices+1];
      vx[0]=new Vertex(c);
      vx[0].setUV(0.5F, 0.5F);
      for(int i=1;i<vx.length;i++){
          vx[i]=new Vertex(0,0,0);
           vx[i].x = (int)(r * Math.cos(angle * (double)i)+c.x);
            vx[i].z = (int)(r * Math.sin(angle * (double)i)+c.z);
            vx[i].y = c.y;
            vx[i].u=(float)(0.5 * Math.cos(angle * (double)i)+0.5);
            vx[i].v=(float)(0.5 * Math.sin(angle * (double)i)+0.5);
      }
      for (int i=0;i<t.length;i++){
          if(i==slices-1)t[i]=new Triangle(vx[0],vx[slices],vx[1],color);
          else t[i]=new Triangle(vx[0],vx[i+1],vx[i+2],color);
          t[i].norm(0,1,0);
          t[i].smooth=false;
          t[i].setUV();
      }
      return t;
  }
  
  public static Face[] cylinder(Vertex c,double r,int h,int slices,int color){
            double angle = 6.2831853071795862D / (double)slices;
      Triangle[] t=new Triangle[slices*4];
      Vertex[] vx=new Vertex[slices+1],v=new Vertex[slices+1];
      vx[0]=new Vertex(c);
      vx[0].u=vx[0].v=0.5f;
      v[0]=new Vertex(c.x,c.y+h,c.z);
      v[0].u=v[0].v=0.5f;
      for(int i=1;i<vx.length;i++){
          vx[i]=new Vertex(0,0,0);
          v[i]=new Vertex(0,0,0);
           vx[i].x= v[i].x = (int)(r * Math.cos(angle * (double)i)+c.x);
            vx[i].z=v[i].z = (int)(r * Math.sin(angle * (double)i)+c.z);
            vx[i].y = c.y;
            v[i].y=c.y+h;
            vx[i].u=(float)(0.5 * Math.cos(angle * (double)i)+0.5);
            vx[i].v=(float)(0.5 * Math.sin(angle * (double)i)+0.5);
            v[i].u=(float)(0.5 * Math.cos(angle * (double)i)+0.5);
            v[i].v=(float)(0.5 * Math.sin(angle * (double)i)+0.5);
      }
      int j;
      for (int i=0;i<=(slices-1)*4;i+=4){
          j=i/4;
          if(i==(slices-1)*4){
              t[i]=new Triangle(vx[0],vx[slices],vx[1],color);
              t[i].norm();
              t[i+1]=new Triangle(vx[slices],vx[1],v[slices],color);
              t[i+1].norm();
              t[i+2]=new Triangle(vx[1],v[slices],v[1],color);
              t[i+2].norm();
              t[i+3]=new Triangle(v[0],v[slices],v[1],color);
              t[i+3].norm();
          }
          else{
              t[i]=new Triangle(vx[0],vx[j+1],vx[j+2],color);
              t[i].norm();
              t[i+1]=new Triangle(vx[j+1],vx[j+2],v[j+1],color);
              t[i+1].norm();
              t[i+2]=new Triangle(vx[j+2],v[j+1],v[j+2],color);
              t[i+2].norm();
              t[i+3]=new Triangle(v[0],v[j+1],v[j+2],color);
              t[i+3].norm();
          }
          t[i].smooth=false;
          t[i+3].smooth=false;
              t[i].setUV();
              t[i+1].setUV();
              t[i+2].setUV();
              t[i+3].setUV();
          if(h>0){t[i+3].invert();t[i+1].invert();}else{t[i].invert();t[i+2].invert();}
      }
        return t;
    }
  
  public static Face[] cone(Vertex c,double r,int h,int slices,int color){
          double angle = 6.2831853071795862D / (double)slices;
      Triangle[] t=new Triangle[slices*2];
      Vertex[] v=new Vertex[slices+2];
      v[0]=new Vertex(c);
      v[v.length-1]=new Vertex(c.x,c.y+h,c.z);
      v[0].u=v[0].v=0.5f;
      v[v.length-1].u=v[v.length-1].v=0.5f;
      for(int i=1;i<v.length-1;i++){
          v[i]=new Vertex(0,0,0);
           v[i].x = (int)(r * Math.cos(angle * (double)i)+c.x);
            v[i].z = (int)(r * Math.sin(angle * (double)i)+c.z);
            v[i].y = c.y;
            v[i].u = (float)(0.5 * Math.cos(angle * (double)i)+0.5);
            v[i].v = (float)(0.5 * Math.sin(angle * (double)i)+0.5);
      }
      int j;
       for (int i=0;i<slices;i++){
           j=i*2;
          if(i==slices-1){
              t[j]=new Triangle(v[0],v[slices],v[1],color);
              t[j].norm();
              t[j+1]=new Triangle(v[1],v[slices],v[v.length-1],color);
              t[j+1].norm();
          }
          else{
              t[j]=new Triangle(v[0],v[i+1],v[i+2],color);
              t[j].norm();
              t[j+1]=new Triangle(v[i+1],v[i+2],v[v.length-1],color);
              t[j+1].norm();
          }
              t[j].smooth=false;
              t[j].setUV();
              t[j+1].setUV();
              if(h>0&&i!=slices-1){t[j+1].invert();}else if(h<0){t[j].invert();if(i==slices-1)t[j+1].invert();}
       }
      return t;
  }
  
  public static Face[] sphere(Vertex c,double gRad,int gnRings,int gnSects,int color){
// общее количество треугольников будет: 

 int gnTria = (gnRings+1) * gnSects * 2; 

 //===Нетрудно подсчитать и общее количество вершин: 

 int gnVert = (gnRings+1) * gnSects + 2;
      //====== Формирование массива вершин 
 Triangle[] t=new Triangle[gnTria];
      Vertex[] v=new Vertex[gnVert];

 //====== Северный полюс 

 v[0] = new Vertex (c.x, c.y+(int)gRad, c.z);

 //====== Индекс последней вершины (на южном полюсе) 

 int last = gnVert - 1; //====== Южный полюс 

 v[last] = new Vertex (c.x, c.y-(int)gRad, c.z); 
 
 v[0].u=v[0].v=0;
 v[last].u=0;
 v[last].v=1;

 //====== Подготовка констант 

 double  da = Math.PI / (gnRings +2), 

 db = 2 * Math.PI / gnSects, 

 af = Math.PI - da/2; 

 double bf = 2 * Math.PI - db/2;

 //=== Индекс вершины, следующей за северным полюсом 

 int n = 1; 

 //=== Цикл по широтам 

 for  (  double  a = da; a < af; a += da) 

 { 

 //=== Координата у постоянна для всего кольца 

 double  у = gRad * Math.cos(a), 

 //====== Вспомогательная точка 

 xz = gRad * Math.sin(a); 

 //====== Цикл по секциям (долгота) 

 for  (  double  b = 0.; b < bf; n++, b += db) 

 { 

 // Координаты проекции в экваториальной плоскости 

 double x = xz * Math.sin(b);
 double z = xz * Math.cos(b); 

 v[n] = new Vertex ((int)x+c.x, (int)у+c.y, (int)z+c.z);
 v[n].u=(float)(b/bf);
 v[n].v=(float)(a/af);
 } } 

 //====== Формирование массива индексов 

 //====== Треугольники вблизи полюсов 

 for  (n = 0; n < gnSects; n++) 

 { 
     t[n]=new Triangle(v[0],v[n + 1],n == gnSects - 1 ? v[1] : v[n + 2],color);
     t[n].norm();
     if(n==gnSects-1)
         t[n].setUV(new float[]{v[0].u,v[0].v,v[n+1].u,v[n+1].v,1,v[n+1].v});
     else t[n].setUV(new float[]{(v[n+1].u+v[n+2].u)/2,v[0].v,v[n+1].u,v[n+1].v,v[n+2].u,v[n+2].v});

 //====== Индекс общей вершины (северный полюс) 


 //====== Индекс общей вершины (южный полюс) 
 t[gnTria-gnSects+n]=new Triangle(v[last],v[last-1-n],v[last-1 - ( (1 + n) % gnSects)],color);
     t[gnTria-gnSects+n].norm();
     if(n==gnSects-1)
         t[gnTria-gnSects+n].setUV(new float[]{v[last].u,v[last].v,v[last-1-n].u,v[last-1-n].v,1,v[last-1-n].v});
     else t[gnTria-gnSects+n].setUV(new float[]{(v[last-1-n].u+v[last-1 - ( (1 + n) % gnSects)].u)/2,v[last].v,v[last-1-n].u,v[last-1 - n].v,v[last-1 - ( (1 + n) % gnSects)].u,v[last-1 - ( (1 + n) % gnSects)].v});

 } 

 //====== Треугольники разбиения колец 

 //====== Вершина, следующая за полюсом 

 int  k = 1; 

 //====== gnSects - номер следующего треугольника 

 n = gnSects; 

 for  (int i = 0; i < gnRings; i++, k += gnSects) { 

 for  (int j = 0; j < gnSects; j++, n += 2) { 

 //======= Индекс общей вершины 

     t[n]=new Triangle(v[k + j],v[k + gnSects + j],v[k + gnSects + ((j + 1) % gnSects)],color);
     t[n].norm();
     if(j==gnSects-1)
         t[n].setUV(new float[]{v[k+j].u,v[k+j].v,v[k+gnSects+j].u,v[k+gnSects+j].v,1,v[k + gnSects + ((j + 1) % gnSects)].v});
     else t[n].setUV(new float[]{v[k+j].u,v[k+j].v,v[k+gnSects+j].u,v[k+gnSects+j].v,v[k + gnSects + ((j + 1) % gnSects)].u,v[k + gnSects + ((j + 1) % gnSects)].v});

 //======= Индекс текущей вершины 


 //======= Замыкание 


 //======= To же для второго треугольника 

 t[n+1]=new Triangle(t[n].a,t[n].c,v[k + ((j + 1) % gnSects)],color); 
     t[n+1].norm();
     if(j==gnSects-1)
         t[n+1].setUV(new float[]{t[n].uv[0],t[n].uv[1],t[n].uv[4],t[n].uv[5],1,v[k + ((j + 1) % gnSects)].v});
     else t[n+1].setUV(new float[]{t[n].uv[0],t[n].uv[1],t[n].uv[4],t[n].uv[5],v[k + ((j + 1) % gnSects)].u,v[k + ((j + 1) % gnSects)].v});

 }}
      return t;
  }
}

/*  public static void calcNormals(Triangle[] faces)
  {
    for (int i = 0; i < faces.length; i++) {
      float ax = faces[i].c.x - faces[i].a.x;
      float ay = faces[i].c.y - faces[i].a.y;
      float az = faces[i].c.z - faces[i].a.z;
      float bx = faces[i].b.x - faces[i].a.x;
      float by = faces[i].b.y - faces[i].a.y;
      float bz = faces[i].b.z - faces[i].a.z;
      float nx = ay * bz - az * by;
      float ny = az * bx - ax * bz;
      float nz = ax * by - ay * bx;
      double l = Math.sqrt(nx * nx + ny * ny + nz * nz);
      faces[i].nx /=l;
      faces[i].ny /=l;
      faces[i].nz /=l;
    }
  }*/
