/*
 * Окно редактора - основная рабочая среда. Самый большой и сложный класс.
 */
import java.util.*;
import javax.microedition.lcdui.*;

public class Editor extends Canvas
{
  Model m; //объект модели
  int w; //ширина экрана
  int h;// высота экрана
  short mode;//режим взаимодействия
  short km;//код клавиш
  short x=20;//поворот по Х
  short y=40;//поворот по Y
  short z;//поворот по Z
  int xo;//сдвиг
  int yo = 0;
  int zo = 0;
  int dist=0;
  int shading=1; // 0 - lambert flat, 1 - lambert, 2 - flat, 3 - wire, 4 - bounding boxes
  short act; // момент создания фигуры
  short in = 0; //текущий инструмент
  short iy; //поворот фигур в окне инструментов
  int color=0xffffff;
  int ex0,ey0,ez0,ex,ey,ez,cDupl,centerX,centerY,centerZ; //переменные для сдвига,поворота и центра при редактировании
  float exs,eys,ezs;
  short view=0; // 0 - perspective, 1 - top, 2 - bottom, 3 - left, 4 - right, 5 - front, 6 - back, 7... - cameras
  short modem=0; // режим окна
  boolean selact; //момент выделения (для select by frame и select3d
  int curselx,cursely,curselz; //для 3д-выделения
  int xs,ys; // координаты сенсорного нажатия
  Matrix3D n; //матрица
  Vertex ver1 = new Vertex(); //точки для создания новой фигуры
  Vertex ver2 = new Vertex();
  Vertex cur = new Vertex(); //курсор
  Image[] modes,instrs; //режимы и инструменты
  Image instr; //иконка текущего инструмента
  String[] innames = { Statics.russian?"Куб":"Box", Statics.russian?"Тор":"Torus", Statics.russian?"Пирамида":"Pyramide" , Statics.russian?"Цилиндр":"Cylinder", Statics.russian?"Конус":"Cone", Statics.russian?"Сфера":"Sphere", Statics.russian?"Диск":"Disk",Statics.russian?"Полигоны":"Triangles",Statics.russian?"Плоскость":"Plane",/*"Линия","Прямоугольник","Окружность","Эллипс","Текст",*/Statics.russian?"Точечный свет":"Omni light"/*,"Направленный"/*,"Прожектор","Свободная","Направленная"*/}; //инструменты
  Image buf; //для двойной буферизации
  Graphics g;
  int[] rgb,rgb2; // экран
  int[] zb,zb2; // Z-буфер
  Group gr; //для POLY
  public static Vector sel,sel2,sel3; // выделение
  Timer timer,mattimer; // таймеры 
  boolean inf=true; // отрисовывать ли софты
  boolean hold=false; // зажатие клавиши
  boolean edges=false; //ребра
  boolean starPressed=false; // нажата ли звездочка
  String name="",vendor="",description="";
  Menu shad,select; // меню для шейдингов и видов
  final int BOX=0,TORUS=1,PYRAMIDE=2,CYLINDER=3,CONE=4,SPHERE=5,DISK=6,POLY=7,PLANE=8,/*LINE=9,RECT=10,CIRCLE=11,ELLIPSE=12,TEXT=13,*/OMNILIGHT=9;//TARGETLIGHT=10;//,SPOTLIGHT=16,FREECAM=17,TARGETCAM=18; // инструменты
  

  public Editor()
  {
    m = new Model();
    init(); }

  public Editor(Model mo) {
    m = mo;
    init();
  }

  //инициализация
  private void init() {
    setFullScreenMode(true);
    w = getWidth();
    h = getHeight();
    buf=Image.createImage(w, h);
    g=buf.getGraphics();
    rgb=new int[w*h];
    zb=new int[w*h];
    n = new Matrix3D();
    name="Model";
    vendor="Vendor";
    /*m.l=new Light[3];
    m.l[1]=new Light(0,0,-300);
    m.l[0]=new Light(0,200,0);
    m.l[2]=new Light(0,0,300);*/
    resetTimer();
    try{
    modes = new Image[]{Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/geom.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/eye.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/move.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/Zoom.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/cursor.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/sel.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/sel3d.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/sellist.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/moveObj.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/rotateObj.png"),Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/scaleObj.png")};
    instr=Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/box.png");
    }catch(Exception e){}
    cls();
    render();
    draw();
  }
  
  //Паинт
  protected void paint(Graphics r){
      if(modem==1)drawInstr(); // режим modem == 1 значит рисуем инструменты
      if(km!=0)sk(km); // опрос клавиш
      if(modem==10){ // окошко дублирования выбранных объектов
          g.setColor(Statics.menuBack);
          int sw=g.getFont().stringWidth(Statics.russian?"Число дубликатов:":"Num of copies"),shh=g.getFont().getHeight();
          g.fillRect(w/2-sw/2, h/2-30, sw, 60);
          g.setColor(0);
          g.drawRect(w/2-sw/2, h/2-30, sw, 60);
          g.setColor(0x777777);
          g.fillRect(w/2-g.getFont().stringWidth("999")/2, h/2-shh/2, g.getFont().stringWidth("999"), shh);
          g.setColor(Statics.textColor);
          g.drawString(Statics.russian?"Число дубликатов:":"Num of copies", w/2-sw/2, h/2-30, 20);
          g.drawString(""+cDupl, w/2-g.getFont().stringWidth("999")/2, h/2-shh/2, 20);
          g.setColor(0x888888);
          g.fillRoundRect(w/2-30, h/4-30, 60, 60, 20, 20);
          g.fillRoundRect(w/2-30, h-h/4-30, 60, 60, 20, 20);
          g.setColor(0);
          g.drawRoundRect(w/2-30, h/4-30, 60, 60, 20, 20);
          g.drawRoundRect(w/2-30, h-h/4-30, 60, 60, 20, 20);
          g.setColor(0xffffff);
          g.fillTriangle(w/2-10, h/4+10, w/2+10, h/4+10, w/2, h/4-10);
          g.fillTriangle(w/2-10, h-h/4-10, w/2+10, h-h/4-10, w/2, h-h/4+10);
          drawLeftSoft("Ok");
          drawRightSoft(Statics.russian?"Отмена":"Cancel");
      }
      if(modem==9){ // окошко выбора по списку
          //draw();
          g.setFont(select.f);
          g.setColor(0xcdcacc);
          int sw=select.f.stringWidth((Statics.russian?"Объектов: ":"Objects: ")+m.g.size()+(Statics.russian?" выбрано: ":"selected: ")+((sel==null||sel.isEmpty())?0:sel.size())+"    "),shh=select.f.getHeight();
          if(shh*((m.g==null?0:m.g.size())+(m.l==null?0:m.l.size())+2)>h){
              g.fillRect(w/2-sw/2, 0, sw, shh*2);
          g.setColor(Statics.menuBack);
          g.fillRect(w/2-sw/2, shh*2, sw, h-shh*2);
          g.setColor(Statics.textColor);
          g.drawString(Statics.russian?"Выбор по списку":"List choice", w/2, 0, 17);
          g.drawString((Statics.russian?"Объектов: ":"Objects: ")+((m.g==null?0:m.g.size())+(m.l==null?0:m.l.size()))+(Statics.russian?" выбрано: ":"selected: ")+((sel==null||sel.isEmpty())?0:sel.size()),w/2, shh, 17);
          g.setClip(w/2-sw/2, shh*2, sw, h-shh*2);
          select.paint(g, w/2-sw/2, shh*2, sw, h-shh*2, 1);
          if(sel!=null){
          g.setColor(0xaa00);
          for(int i=0;i<sel.size();i++){
              if(sel.elementAt(i) instanceof Light)
                  g.drawString((m.l.indexOf(sel.elementAt(i))+1)+". Omnilight", w/2, m.l.indexOf(sel.elementAt(i))*shh+select.yy+select.by, 17);
             else g.drawString((m.g.indexOf(sel.elementAt(i))+(m.l==null?0:m.l.size())+1)+". "+((Group)(sel.elementAt(i))).name, w/2, (m.g.indexOf(sel.elementAt(i))+(m.l==null?0:m.l.size()))*shh+select.yy+select.by, 17);
          }
          }
          g.setClip(0, 0, w, h);
          g.setColor(0);
          g.drawRect(w/2-sw/2, shh*2, sw, h-shh*2-1);
          }
          else{
              int sz=((m.g==null?0:m.g.size())+(m.l==null?0:m.l.size()));
          g.fillRect(w/2-sw/2, h/2-shh*sz/2-shh*2, sw, shh*sz+shh*2);
          g.setColor(Statics.menuBack);
          g.fillRect(w/2-sw/2, h/2-shh*sz/2, sw, shh*sz);
          g.setColor(Statics.textColor);
          g.drawString(Statics.russian?"Выбор по списку":"List choice", w/2, h/2-shh*sz/2-shh*2, 17);
          g.drawString((Statics.russian?"Объектов: ":"Objects: ")+sz+(Statics.russian?" выбрано: ":"selected: ")+((sel==null||sel.isEmpty())?0:sel.size()),w/2, h/2-shh*(m.g.size()+(m.l==null?0:m.l.size()))/2-shh, 17);
          g.setClip(w/2-sw/2, h/2-shh*sz/2, sw, shh*sz);
          select.paint(g, w/2-sw/2, h/2-shh*sz/2, sw, shh*sz+5, 1);
          if(sel!=null){
          g.setColor(0xaa00);
          for(int i=0;i<sel.size();i++){
              if(sel.elementAt(i) instanceof Light)
                  g.drawString((m.l.indexOf(sel.elementAt(i))+1)+". Omnilight", w/2, m.l.indexOf(sel.elementAt(i))*shh+select.yy+select.by, 17);
             else g.drawString((m.g.indexOf(sel.elementAt(i))+(m.l==null?0:m.l.size())+1)+". "+((Group)(sel.elementAt(i))).name, w/2, (m.g.indexOf(sel.elementAt(i))+(m.l==null?0:m.l.size()))*shh+select.yy+select.by, 17);
          }
          }
          g.setClip(0, 0, w, h);
          g.setColor(0);
          g.drawRect(w/2-sw/2, h/2-shh*sz/2-shh*2, sw, shh*sz+shh*2);
          }
          drawRightSoft("Ok");
          drawLeftSoft(Statics.russian?"Опции":"Options");
          if(act>0){ // опции по левому софткею при выборе по списку
              g.setColor(Statics.menuBack);
              g.fillRect(0, h-shh*2, Statics.font.stringWidth(Statics.russian?"Выделить все":"Select all")+3, shh*2);
              g.setColor(0xaaaa00);
              g.fillRect(0,h-(act)*shh-1, Statics.font.stringWidth(Statics.russian?"Выделить все":"Select all")+3, shh);
              g.setColor(Statics.textColor);
              g.drawString(Statics.russian?"Выделить все":"Select all", 2, h-shh*2, 20);
              g.drawString(Statics.russian?"Снять все":"Deselect", 2, h-shh, 20);
              g.setColor(0);
              g.drawRect(0, h-shh*2-1, Statics.font.stringWidth(Statics.russian?"Выделить все":"Select all")+3, shh*2);
          }
      }
    if(modem==4||modem==3||modem==5){ // modem 3,4,5 - это выбор режима при нажатии на 0.
        g.drawRGB(rgb, 0, w, 0, 0, w, h, false);
        if(modem==3){
          if(mode>3)mode=0;
          if(mode<0)mode=3;}
          else if(modem==4){
          if(mode>7)mode=4;
          if(mode<4)mode=7;}
          else if(modem==5){
              if(mode>10)mode=8;
              if(mode<8)mode=10;}
        g.setColor(Statics.menuBack);
        g.fillRect(0, h-(Statics.bigImages?67:37), w, (Statics.bigImages?67:37));
        g.setColor(0);
        g.drawRect(1, h-(Statics.bigImages?66:36), w-3, (Statics.bigImages?64:34));
        int ai,bi;
        if(modem==3){ai=0;bi=4;}else if(modem==4){ai=4;bi=4;}else {ai=8;bi=3;}
        for(int i=0;i<bi;i++)
            g.drawImage(modes[i+ai], i*(Statics.bigImages?65:35)+3,h-(Statics.bigImages?64:34), 20);
        g.drawRect((mode-ai)*(Statics.bigImages?65:35)+3, h-(Statics.bigImages?64:34), (Statics.bigImages?60:30), (Statics.bigImages?60:30));
        g.setColor(0x777777);
        if(Statics.touch){
            if(modem!=3)g.fillTriangle(w/2-20, h-(Statics.bigImages?95:65), w/2-30, h-(Statics.bigImages?75:45), w/2-10, h-(Statics.bigImages?75:45));
            if(modem!=5)g.fillTriangle(w/2+20, h-(Statics.bigImages?75:45), w/2+30, h-(Statics.bigImages?95:65), w/2+10, h-(Statics.bigImages?95:65));
        }
        else{
            if(modem>3)g.fillTriangle(w/2, h-(Statics.bigImages?65:35), w/2-5, h-(Statics.bigImages?62:32), w/2+5, h-(Statics.bigImages?62:32));
            if(modem<5)g.fillTriangle(w/2, h-3, w/2-5, h-6, w/2+5, h-6);
        }
    }
    else if(modem==2){ // меню выбора шейдинга и обзора
        g.setColor(Statics.menuBack);
        g.fillRect(0, 0, shad.f.stringWidth(Statics.russian?"описанные боксы":"Bounding boxes"), h);
        g.setColor(0);
        g.drawRect(0, 0, shad.f.stringWidth(Statics.russian?"описанные боксы":"Bounding boxes"), h);
        shad.paint(g, 0, 0, shad.f.stringWidth(Statics.russian?"описанные боксы":"Bounding boxes"), h, 0);
    }
      r.drawImage(buf, 0, 0, 20);
      repaint();
  }
  private void cls(){ // очищение экрана и буфера глубины. Обычное и быстрое с дополнительными буферами, ведь arraycopy очень быстр.
      if(rgb2!=null&&zb2!=null){
          if(!Statics.extraBuffers){rgb2=null;zb2=null;cls();}
          else{
      System.arraycopy(rgb2, 0, rgb, 0, rgb.length);
      System.arraycopy(zb2, 0, zb, 0, zb.length);}
      }
      else{
          if(Statics.extraBuffers){clearBuffers(); }
          else
          for (int i=0;i<rgb.length;i++){
          zb[i]=Integer.MAX_VALUE;
          rgb[i]=Statics.edBack;
          }
      }
  }
  public void clearBuffers(){ // очищаем и заполняем ВСЕ буфера
      if(!Statics.extraBuffers)return;
      if(rgb2==null)rgb2=new int[w*h];
      if(zb2==null) zb2=new int[w*h];
      for (int i=0;i<rgb2.length;i++){
          zb2[i]=zb2[i]=Integer.MAX_VALUE;
          rgb[i]=rgb2[i]=Statics.edBack;
          }
  }
  
  //клавиши в работе
  private void sk(short k){
      if((k<48||k>57)&&view==0){ // вращение обзора посредством навигационных клавиш или джойстика
          int ga=getGameAction(k);
      switch(ga){
          case UP: x-=5;if(x>360)x-=360;render();break;
          case DOWN: x+=5;if(x<0)x+=360;render();break;
          case RIGHT: y+=5;if(y>360)y-=360;render();break;
          case LEFT: y-=5;if(y<0)y+=360;render();break;
      }
      }
      if(mode==0||mode==6){ // mode 0 - добавление геометрии, 6 - трехмерное выделение
          if(view==0){ // view 0 - перспективный обзор
          int sp=50;
          if(dist>3000)sp=100;
          if(dist>5000)sp=200;
          switch(k){
         case 50: cur.y+=sp;break;
         case 56: cur.y -= sp; break;
        case 52:
          cur.x -= sp; break;
        case 54:
          cur.x += sp;break;
        case 49: cur.z-=sp;break;
        case 51: cur.z+=sp;break;
      }
          }
          else{ // остальные view - боковые проекции
              int sp=50;
              if(dist>10000)sp=10;
          else if(dist>3000)sp=30;
              switch(k){
                  case 50: if(view==1)cur.z+=sp;else cur.y+=sp; break;
                  case 56: if(view==1)cur.z-=sp;else cur.y-=sp; break;
                  case 52: if(view==1||view==3)cur.x-=sp; else cur.z-=sp; break;
                  case 54: if(view==1||view==3)cur.x+=sp; else cur.z+=sp; break;
              }
          }
      }
      else if(mode==1&&view==0){ // mode 1 - обзор вращением
          switch (k) {
          case 50: x -= 5;if(x<0)x+=360;render(); break;
        case 56: x += 5;if(x>360)x-=360;render(); break;
        case 52: y -= 5;if(y<0)y+=360;render(); break;
        case 54: y += 5;if(y>360)y-=360;render(); break;
        case 49: z -= 5;if(z<0)z+=360;render(); break;
        case 51: z += 5;if(z>360)z-=360;render();}
      }
      else if(mode==2){ // mode 2 - смещение
          int sp=100;
          if(view==0){
          if(dist>7000)sp=300;
          else if(dist>5000)sp=200;
          else if(dist>3000)sp=150;
          switch (k) {
        case 50:
          yo -= sp;render(); break;
        case 56:
          yo += sp;render(); break;
        case 52:
          xo += sp;render(); break;
        case 54:
          xo -= sp;render(); break;
        case 49:
          zo -= sp;render(); break;
        case 51:
          zo += sp;render();}
          }
          else{
          if(dist>10000)sp=10;
          else if(dist>3000)sp=50;
          switch (k) {
        case 50:
          if(view==1)zo-=sp; else yo -= sp; render(); break;
        case 56:
          if(view==1)zo+=sp; else yo += sp; render(); break;
        case 52:
          if(view==2)zo+=sp; else xo += sp;render(); break;
        case 54:
          if(view==2)zo-=sp; else xo -= sp;render(); break;
          }
          }
      }
      else if(mode==3){ // масштабирование
          if(k==50){ if(view!=0&&dist<-5000)dist-=20;else if(view!=0&&dist>2000)dist-=200; else dist-=100;render();}
          if(k==56){ if(view!=0&&dist<-5000)dist+=20;else if(view!=0&&dist>2000)dist+=200; else dist+=100;render();}
      }
      else if(mode==4||mode==5){ // выделение
          switch(k){
              case 50: cur.sy-=3;break;
              case 56: cur.sy+=3;break;
              case 52: cur.sx-=3;break;
              case 54: cur.sx+=3;break;
          }
      }
      else if(mode==8){ // движение выделенного
          int sp=20;
          if(dist>3000)sp=50;
          if(dist>5000)sp=100;
          switch(k){
              case 50: ey0+=sp;render();break;
              case 56: ey0-=sp;render();break;
              case 52: ex0-=sp;render();break;
              case 54: ex0+=sp;render();break;
              case 49: ez0+=sp;render();break;
              case 51: ez0-=sp;render();break;
          }
      }
      else if(mode==9){ // вращение выделенного
          switch(k){
              case 50: ex-=2;render();break;
              case 56: ex+=2;render();break;
              case 52: ey+=2;render();break;
              case 54: ey-=2;render();break;
              case 49: ez+=2;render();break;
              case 51: ez-=2;render();break;
          }
      }
      else if(mode==10){ // масштабирование выделенного
          switch(k){
              case 50: eys*=1.02;render();break;
              case 56: eys/=1.02;render();break;
              case 52: exs/=1.02;render();break;
              case 54: exs*=1.02;render();break;
              case 49: ezs/=1.02;render();break;
              case 51: ezs*=1.02;render();break;
          }
      }

      draw();
  }
  
  public void setMatrix(){ // настраиваем матрицу на текущее положение
      n.unit();
    n.translate(xo, yo, zo);
    n.yrot(y);
    n.xrot(x);
    n.zrot(z);
    n.translate(0, 0, dist);
  }
  
  // визуализация сцены
  public void render(){
      cls();
    setMatrix();
    if(Statics.grid)drawGrid();
   // m.render(rgb,zb, n,shading);
    if(m.l!=null){for(int i=0;i<m.l.size();i++){
        if(mode==8&&act==1&&sel.contains(m.l.elementAt(i))){((Light)m.l.elementAt(i)).x+=ex0;((Light)m.l.elementAt(i)).y+=ey0;((Light)m.l.elementAt(i)).z+=ez0; }
        if(m.l.elementAt(i)!=null)((Light)m.l.elementAt(i)).setMatrix(n);
        if(mode==8&&act==1&&sel.contains(m.l.elementAt(i))){((Light)m.l.elementAt(i)).x-=ex0;((Light)m.l.elementAt(i)).y-=ey0;((Light)m.l.elementAt(i)).z-=ez0; }
    }}
    if(view!=0&&shading==1)shading=0;
    if (!m.g.isEmpty()){for(int i=0;i<m.g.size();i++){
        Group gro=(Group)m.g.elementAt(i);
        if(!(sel!=null&&sel.contains(gro)&&mode>7&&mode<11&&act==1&&Edit.mo==0))gro.render(rgb, zb, n,m.l,shading,view);
    }}
    if(sel!=null&&!sel.isEmpty()&&Edit.mo==0){
            for(int i=0;i<sel.size();i++){
                if(sel.elementAt(i) instanceof Light)continue;
            Group sell=(Group)sel.elementAt(i);
        if(act==1){
            if(starPressed)sell.render(rgb, zb, n, m.l, shading,view);
        if(mode==8){
            n.unit();
            n.translate(ex0, ey0, ez0);
            n.translate(xo, yo, zo);
            n.yrot(y);
            n.xrot(x);
            n.zrot(z);
            n.translate(0, 0, dist);
        }
        else if(mode==9){
            n.unit();
            n.translate(-centerX, -centerY, -centerZ);
            n.yrot(ey);
            n.xrot(ex);
            n.zrot(ez);
            n.translate(centerX, centerY, centerZ);
            n.translate(xo, yo, zo);
            n.yrot(y);
            n.xrot(x);
            n.zrot(z);
            n.translate(0, 0, dist);
        }
        else if(mode==10){
            n.unit();
            n.translate(-centerX, -centerY, -centerZ);
            n.scale(exs, eys, ezs);
            n.translate(centerX, centerY, centerZ);
            n.translate(xo, yo, zo);
             n.yrot(y);
            n.xrot(x);
            n.zrot(z);
            n.translate(0, 0, dist);
        }
        sell.render(rgb, zb, n, m.l, shading,view);
            setMatrix();
        }
        Group gro=new Group(Create.wireBox(new Vertex(sell.minx,sell.miny,sell.minz), new Vertex(sell.maxx,sell.maxy,sell.maxz), 0xffffff),null,-1);
                 gro.render(rgb, zb, n, null, 3,view);
                 Vertex grcen=new Vertex(sell.ax,sell.ay,sell.az),grc1=new Vertex(sell.ax+300,sell.ay,sell.az),grc2=new Vertex(sell.ax,sell.ay+300,sell.az),grc3=new Vertex(sell.ax,sell.ay,sell.az+300);
                 grcen.setMatrix(n);
                 grc1.setMatrix(n);
                 grc2.setMatrix(n);
                 grc3.setMatrix(n);
                 (new Line(grcen,grc1,0xff0000)).render(rgb, zb, view);
                 (new Line(grcen,grc2,0xff0000)).render(rgb, zb, view);
                 (new Line(grcen,grc3,0xff0000)).render(rgb, zb, view);
            }
    }
  }
  
  public void resetTimer(){ // сброс таймера, что следит за отрисовкой софт-кнопок по бокам, они исчезают через три секунды
      inf=true;
      if(timer!=null){
          timer.cancel();
          timer=null;
      }
          timer=new Timer();
      TimerTask mt=new TimerTask(){
          public void run(){
              inf=false;
              if(modem==0)draw();
          }
      };
      timer.schedule(mt, 3000);
  }
  
  //метод отрисовки интерфейса
  
  public void draw(){
      if(modem==1)return;
      g.drawRGB(rgb, 0, w, 0, 0, w, h, false);
    if(act>0&&mode==0)
    drawNewObj();
     if((Edit.mo==1||Edit.mo==2)&&act==1){
         if(mode==8){
            n.unit();
            n.translate(ex0, ey0, ez0);
            n.translate(xo, yo, zo);
            n.yrot(y);
            n.xrot(x);
            n.zrot(z);
            n.translate(0, 0, dist);
        }
        else if(mode==9){
            n.unit();
            n.translate(-centerX, -centerY, -centerZ);
            n.yrot(ey);
            n.xrot(ex);
            n.zrot(ez);
            n.translate(centerX, centerY, centerZ);
            n.translate(xo, yo, zo);
            n.yrot(y);
            n.xrot(x);
            n.zrot(z);
            n.translate(0, 0, dist);
        }
        else if(mode==10){
            n.unit();
            n.translate(-centerX, -centerY, -centerZ);
            n.scale(exs, eys, ezs);
            n.translate(centerX, centerY, centerZ);
            n.translate(xo, yo, zo);
             n.yrot(y);
            n.xrot(x);
            n.zrot(z);
            n.translate(0, 0, dist);
        }
     }
         if(Edit.mo==1&&sel2!=null&&!sel2.isEmpty()){
        for(int i=0;i<sel2.size();i++){
            ((Triangle)sel2.elementAt(i)).setVertexMatrix(n);
            ((Triangle)sel2.elementAt(i)).paint(g, 0xff0000, view);
        }
        setMatrix();
    }
    else if(Edit.mo==2&&sel3!=null&&!sel3.isEmpty()){
         for(int i=0;i<sel3.size();i++){
             Vertex ver=(Vertex)sel3.elementAt(i);
             ver.setMatrix(n);
             g.setColor(0xff0000);
             g.fillRect(ver.sx-6,ver.sy-6,12,12);
         }
         setMatrix();
     }
    if(m.l!=null)for(int i=0;i<m.l.size();i++){
        if(m.l.elementAt(i) !=null){
    g.setColor(sel!=null&&sel.contains(m.l.elementAt(i))?0xff0000:0xffffff);
    g.fillArc(((Light)m.l.elementAt(i)).sx-10,((Light)m.l.elementAt(i)).sy-10, 20, 20, 0, 360);}}
    if(mode==5&&selact){
        g.setColor(0);
        int cursx,cursy;
        if(Statics.touch){
        cursx=xs<curselx?xs:curselx;
        cursy=ys<cursely?ys:cursely;}
        else{
            cursx=cur.sx<curselx?cur.sx:curselx;
        cursy=cur.sy<cursely?cur.sy:cursely;
        }
    g.setStrokeStyle(Graphics.DOTTED);
    g.drawRect(cursx, cursy, Math.abs((Statics.touch?xs:cur.sx)-curselx), Math.abs((Statics.touch?ys:cur.sy)-cursely));
    g.setStrokeStyle(Graphics.SOLID);
    }
    if(mode==6&&selact){
        Group gro;
        if(Statics.touch&&ver1!=null){
            ver1.setMatrix(n);
            int vrx=(int)Math.sqrt((ver1.sx-xs)*(ver1.sx-xs)+(ver1.sy-ys)*(ver1.sy-ys))*10;
            gro=new Group(Create.wireBox(new Vertex(ver1.x-vrx,ver1.y-vrx,ver1.z-vrx), new Vertex(ver1.x+vrx,ver1.y+vrx,ver1.z+vrx), 0),"",-1);}
        else gro=new Group(Create.wireBox(new Vertex(curselx,cursely,curselz), cur, 0),"",-1);
        gro.draw(g, n, null);
    }
    drawCursor();
    g.drawImage(instr, w, 0, Graphics.TOP|Graphics.RIGHT);
    g.setColor(color);
    g.fillRect(w-(Statics.bigImages?125:65), 0, (Statics.bigImages?60:30), (Statics.bigImages?60:30));
    g.setColor(Statics.textColor);
    g.setFont(Statics.font);
    if(mode==0||mode==6)g.drawString("x:"+(cur.x/10)+"; y:"+(cur.y/10)+"; z:"+(cur.z/10), 0, 0, 20);
    else if(mode==1) g.drawString("yz:"+x+"; xz:"+y+"; xy:"+z, 0, 0, 20);
    else if(mode==2) g.drawString("cx:"+(xo/10)+"; cy:"+(yo/10)+"; cz:"+(zo/10), 0, 0, 20);
    else if (mode==3) g.drawString("dist:"+(dist+300), 0, 0, 20);
    g.fillRoundRect(w/2-(Statics.bigImages?33:20), h-(Statics.bigImages?62:31), (Statics.bigImages?65:40), (Statics.bigImages?60:30), 7, 7);
    g.setColor(0);
    g.drawRect(w-(Statics.bigImages?60:30), 0, (Statics.bigImages?60:30)-1, (Statics.bigImages?60:30));
    g.drawRoundRect(w/2-(Statics.bigImages?33:20), h-(Statics.bigImages?62:31), (Statics.bigImages?65:40), (Statics.bigImages?60:30), 7, 7);
    g.drawRect(w-(Statics.bigImages?125:65), 0, (Statics.bigImages?60:30), (Statics.bigImages?60:30));
    if(mode>=8&&act==1&&Statics.touch){
        g.drawRect(3,(Statics.bigImages?63:33),w-6,h-(Statics.bigImages?106:76));
        g.drawLine(w/3,(Statics.bigImages?63:33),w/3,h-43);
        g.drawLine(w*2/3,(Statics.bigImages?63:33),w*2/3,h-43);
        g.setColor(Statics.textColor);
        if(mode==8){
        g.drawString("X "+ex0/10, w/3, (Statics.bigImages?63:33), Graphics.RIGHT|Graphics.TOP);
        g.drawString("Y "+ey0/10, w/2, (Statics.bigImages?63:33), 17);
        g.drawString("Z "+ez0/10, w*2/3+1, (Statics.bigImages?63:33), 20);
        }
        else if(mode==9){
            g.drawString("X "+ex, w/3, (Statics.bigImages?63:33), Graphics.RIGHT|Graphics.TOP);
        g.drawString("Y "+ey, w/2, (Statics.bigImages?63:33), 17);
        g.drawString("Z "+ez, w*2/3+1, (Statics.bigImages?63:33), 20);
        }
        else if(mode==10){
            g.drawString("X "+(String.valueOf(exs)).substring(0, (String.valueOf(exs).indexOf('.')+2)), w/3, (Statics.bigImages?63:33), Graphics.RIGHT|Graphics.TOP);
        g.drawString("Y "+(String.valueOf(eys)).substring(0, (String.valueOf(eys).indexOf('.')+2)), w/2, (Statics.bigImages?63:33), 17);
        g.drawString("Z "+(String.valueOf(ezs)).substring(0, (String.valueOf(ezs).indexOf('.')+2)), w*2/3+1, (Statics.bigImages?63:33), 20);
        }
        String s=Statics.russian?"Дубликат":"Copy";
        g.setColor(starPressed?0xbb3333:8947967);
            g.fillRoundRect(w-g.getFont().stringWidth(s)-5, h - 80, g.getFont().stringWidth(s)+5, 39,15,15);
            g.setColor(0);
        g.drawRoundRect(w-g.getFont().stringWidth(s)-5, h-80, g.getFont().stringWidth(s)+4, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, w - 4, h+Statics.font.getHeight()/2- 60, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, w - 3, h+Statics.font.getHeight()/2 - 59, 40);
    }
    g.drawImage(modes[mode], w/2, h-1, Graphics.BOTTOM|Graphics.HCENTER);
    if(mode==4&&Statics.touch){
        String s=Statics.russian?"Добавить":"Add";
        g.setColor(starPressed?0xbb3333:8947967);
            g.fillRoundRect(w-g.getFont().stringWidth(s)-5, h - 80, g.getFont().stringWidth(s)+5, 39,15,15);
            g.setColor(0);
        g.drawRoundRect(w-g.getFont().stringWidth(s)-5, h-80, g.getFont().stringWidth(s)+4, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, w - 4, h+Statics.font.getHeight()/2- 60, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, w - 3, h+Statics.font.getHeight()/2 - 59, 40);
    }
    if(inf==true||Statics.touch&&modem!=9){
        if(in==POLY&&act>0&&mode==0)
    drawRightSoft("Ok");
        else if(mode>=8&&act==1)drawRightSoft(Statics.russian?"Отмена":"Cancel");
        else drawRightSoft(Statics.russian?"Меню":"Menu");
    if(mode>=8)drawLeftSoft("Ok"); else drawLeftSoft(Statics.touch?(Statics.russian?"Редакт":"Edit"):(Statics.russian?"Инстр":"Geometry"));
    }
  }
  
  private void drawFlatArray(Face[] t){ // метод отрисовки плоской закраской
  for (int i = t.length-1; i >=0 ; i--) {
        if(t[i]!=null&&t[i] instanceof Triangle){
        t[i].setVertexMatrix(n);
      t[i].setMatrix(n);
      ((Triangle)t[i]).paintFlat(g);
        }
    }
  }
  
  private void drawArray(Face[] t,int v){
      drawArray(t,true,v);
  }
  
  //нарисовать массив полигонов, учитывая выбор сортировки
   private void drawArray(Face[] t,boolean sr,int v) {
    if(sr){for (int i = 0; i < t.length; i++) {
    if(t[i]!=null)t[i].setVertexMatrix(n);
    }
    Ksort.sort(t);
    }
    for (int i = t.length-1; i >=0 ; i--) {
        if(t[i]!=null){
        if(!sr)t[i].setVertexMatrix(n);
      t[i].setMatrix(n);
      t[i].light(null);
      t[i].paint(g,v);
        }
    }
  }
   
   //нарисовать новый объект, тот, что сейчас создается
    private void drawNewObj() {
    if(ver1!=null)ver1.setMatrix(n);
    if(ver2!=null)ver2.setMatrix(n);
    if(Statics.touch){
    if (in == BOX){
        int vrx=(int)Math.sqrt((ver1.sx-xs)*(ver1.sx-xs)+(ver1.sy-ys)*(ver1.sy-ys))*10;
      drawArray( Create.box(new Vertex(ver1.x-vrx,ver1.y-vrx,ver1.z-vrx),new Vertex(ver1.x+vrx,ver1.y+vrx,ver1.z+vrx) , color),view);}
    else if (in == TORUS){
        drawArray(Create.torus(ver1, Math.abs(ver1.sx-xs)*10,Math.abs(ver1.sy-ys)*10, 5, 5, color),view);
    }
    else if (in == PYRAMIDE){
        drawArray(Create.pyramid(ver1, new Vertex(ver1.x+Math.abs(ver1.sx-xs)*10,ver1.y,ver1.z+Math.abs(ver1.sx-xs)*10), (ver1.sy-ys)*10, color),view);
    }
    else if (in == CYLINDER) drawArray( Create.cylinder(ver1,Math.abs(ver1.sx-xs)*10, (ver1.sy-ys)*10, 10, color),view);
    else if (in == CONE) drawArray( Create.cone(ver1, Math.abs(ver1.sx-xs)*10, (ver1.sy-ys)*10, 10, color),view);
    else if( in == SPHERE) drawArray( Create.sphere(ver1, Math.sqrt((ver1.sx-xs)*(ver1.sx-xs)+(ver1.sy-ys)*(ver1.sy-ys))*10, 10, 10, color),view);
    else if(in==DISK){
        if(act==1) drawArray(Create.disk(ver1,Math.sqrt((ver1.sx-xs)*(ver1.sx-xs)+(ver1.sy-ys)*(ver1.sy-ys))*10, 10, color),view);
    }
    else if(in==POLY){gr.draw(g, n,null);
        if(act==2){
            g.setColor(0xbb0000);
            g.fillRect(ver1.sx - 1, ver1.sy - 10, 2, 20);
    g.fillRect(ver1.sx - 10, ver1.sy - 1, 20, 2);
    g.setColor(0);
    g.fillRect(ver1.sx - 4, ver1.sy - 4, 8, 8);
        }
        if(act==3){ 
            g.setColor(0xbb0000);
            g.fillRect(ver1.sx - 1, ver1.sy - 10, 2, 20);
            g.fillRect(ver1.sx - 10, ver1.sy - 1, 20, 2);
            g.fillRect(ver2.sx - 1, ver2.sy - 10, 2, 20);
            g.fillRect(ver2.sx - 10, ver2.sy - 1, 20, 2);
            g.setColor(0);
            g.fillRect(ver1.sx - 4, ver1.sy - 4, 8, 8);
            g.fillRect(ver2.sx - 4, ver2.sy - 4, 8, 8);
            g.setColor(color);
            g.drawLine(ver1.sx, ver1.sy, ver2.sx, ver2.sy);}
    }
    else if(in==PLANE){
        if(act==1) drawArray(Create.plane(new Vertex(ver1.x-Math.abs(ver1.sx-xs)*10,ver1.y,ver1.z-Math.abs(ver1.sy-ys)*10), new Vertex(ver1.x+Math.abs(ver1.sx-xs)*10,ver1.y,ver1.z+Math.abs(ver1.sy-ys)*10), color),view);
    }
    }
    else{
    if (in == BOX){
      drawArray( Create.box(ver1, cur, color),view);}
    else if (in == TORUS){
        drawArray(Create.torus(ver1, (int)Math.sqrt((cur.x - ver1.x) * (cur.x - ver1.x) + (cur.z - ver1.z) * (cur.z - ver1.z)), (int)Math.sqrt((cur.y-ver1.y)*(cur.y-ver1.y)), 5, 5, color),view);
    }
    else if (in == PYRAMIDE){
        drawArray( Create.pyramid(ver1, new Vertex(cur.x,ver1.y,cur.z), cur.y-ver1.y, color),view);
    }
    else if (in == CYLINDER) drawArray( Create.cylinder(ver1,Math.sqrt((cur.x-ver1.x)*(cur.x-ver1.x)+(cur.z-ver1.z)*(cur.z-ver1.z)), cur.y-ver1.y, 10, color),view);
    else if (in == CONE) drawArray( Create.cone(ver1, Math.sqrt((cur.x-ver1.x)*(cur.x-ver1.x)+(cur.z-ver1.z)*(cur.z-ver1.z)), cur.y-ver1.y, 10, color),view);
    else if( in == SPHERE) drawArray( Create.sphere(ver1, Math.sqrt((cur.x - ver1.x) * (cur.x - ver1.x) + (cur.z - ver1.z) * (cur.z - ver1.z)+(cur.y-ver1.y)*(cur.y-ver1.y)), 10, 10, color),view);
    else if(in==DISK){
        if(act==1) drawArray(Create.disk(ver1,Math.sqrt((cur.x-ver1.x)*(cur.x-ver1.x)+(cur.z-ver1.z)*(cur.z-ver1.z)), 10, color),view);
    }
    else if(in==POLY){gr.draw(g, n,null);
        g.setColor(color);
        if(act==2){g.drawLine(ver1.sx, ver1.sy, cur.sx, cur.sy);}
        if(act==3) g.fillTriangle(ver1.sx, ver1.sy, ver2.sx, ver2.sy, cur.sx, cur.sy);
    }
    else if(in==PLANE){
        if(act==1) drawArray(Create.plane(ver1, cur, color),view);
    }
    }
  }
    
    private void drawLeftSoft(String s){
        int sh=g.getFont().getHeight();
        if(!Statics.touch){
        g.setColor(8947967);
        g.fillRoundRect(0, h - sh+1, g.getFont().stringWidth(s)+5, sh-1,10,10);
        g.setColor(0);
        g.drawRoundRect(0, h - sh+1, g.getFont().stringWidth(s)+5, sh-2,10,10);
        g.setColor(0x555555);
        g.drawString(s, 2, h - 2, 36);
        g.setColor(Statics.textColor);
        g.drawString(s, 3, h - 1, 36);}
        else{
            g.setColor(8947967);
        g.fillRoundRect(0, h - 40, g.getFont().stringWidth(s)+5, 39,15,15);
        g.setColor(0);
        g.drawRoundRect(0, h - 40, g.getFont().stringWidth(s)+5, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, 2, h + sh/2 - 20, 36);
        g.setColor(Statics.textColor);
        g.drawString(s, 3, h +sh/2 - 19, 36);
        }
    }
    
    private void drawRightSoft(String s){
        int sh=g.getFont().getHeight();
        if(!Statics.touch){
        g.setColor(8947967);
        g.fillRoundRect(w-g.getFont().stringWidth(s)-5, h - sh + 1, g.getFont().stringWidth(s)+5, sh-1,10,10);
        g.setColor(0);
        g.drawRoundRect(w-g.getFont().stringWidth(s)-5, h - sh + 1, g.getFont().stringWidth(s)+4, sh-2,10,10);
        g.setColor(0x555555);
        g.drawString(s, w - 4, h - 2, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, w - 3, h - 1, 40);}
        else{
            g.setColor(8947967);
            g.fillRoundRect(w-g.getFont().stringWidth(s)-5, h - 40, g.getFont().stringWidth(s)+5, 39,15,15);
            g.setColor(0);
        g.drawRoundRect(w-g.getFont().stringWidth(s)-5, h-40, g.getFont().stringWidth(s)+4, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, w - 4, h+sh/2- 20, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, w - 3, h+sh/2 - 19, 40);
        }
    }

    //3Д-сетка
  private void drawGrid() {
    if(view==0){
    for (int i = -1000; i <= 1000; i += 100) {
      Vertex v = new Vertex(i, 0, -1000);
      Vertex v2 = new Vertex(i, 0, 1000);
      v.setMatrix(n);
      v2.setMatrix(n);
      (new Line(v,v2,Statics.gridColor)).render(rgb, zb);
      v = new Vertex(-1000, 0, i);
      v2 = new Vertex(1000, 0, i);
      v.setMatrix(n);
      v2.setMatrix(n);
      (new Line(v,v2,Statics.gridColor)).render(rgb, zb);
    }}
    else{
          for(int i=0;i<w;i+=10){
              for(int j=i;j<rgb.length;j+=w)rgb[j]=Statics.gridColor;
          }
              for(int i=0;i<h;i+=10){
                  for(int j=i*w;j<i*w+w;j++)rgb[j]=Statics.gridColor;
              }
    }
  }

  //рисование курсора
  private void drawCursor() {
      if(mode!=0&&(mode<4||mode>6)||Statics.touch)return;
      int cx=0,cy=0;
    if(mode==0||mode==6)cur.setMatrix(n);
    g.setColor(Statics.curColor);
    if(view==0||mode==5||mode==4){cx=cur.sx;cy=cur.sy;}
    else if(view==1){double distsc=(double)dist;
        if(distsc>0)distsc=distsc/10000+0.1;
        else if(distsc==0)distsc=0.1;
        else distsc=0.1+distsc/100000;
        cx=(int)(w/2+xo*distsc+cur.x*distsc);cy=(int)(h/2-zo*distsc-cur.z*distsc);}
    else if(view==2){double distsc=(double)dist;
        if(distsc>0)distsc=distsc/10000+0.1;
        else if(distsc==0)distsc=0.1;
        else distsc=0.1+distsc/100000;
        cx=(int)(w/2+zo*distsc+cur.z*distsc);cy=(int)(h/2-yo*distsc-cur.y*distsc);}
    else if(view==3){double distsc=(double)dist;
        if(distsc>0)distsc=distsc/10000+0.1;
        else if(distsc==0)distsc=0.1;
        else distsc=0.1+distsc/100000;
        cx=(int)(w/2+xo*distsc+cur.x*distsc);cy=(int)(h/2-yo*distsc-cur.y*distsc);}
    g.fillRect(cx - 1, cy - 10, 2, 20);
    g.fillRect(cx - 10, cy - 1, 20, 2);
    g.setColor(0);
    g.fillRect(cx - 4, cy - 4, 8, 8); }
    
    private void ci(String sin,int i){
        try{
    instrs[i]=Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/"+sin+".png");
        }catch(Exception e){}
    }
  
  //отрисовка окна инструментов
   private void drawInstr() {
    int sh=g.getFont().getHeight();
    g.setColor(Statics.menuBack);
    g.fillRect(0, 0, w, h);
    n.unit();
    n.yrot(iy);
    n.xrot(30);
    n.translate(0F, 0F, 100.0F);
    int itmp=0;
       if(instrs==null){
       if(in<=OMNILIGHT){
       instrs=new Image[10];
       ci("box",BOX);
       ci("torus",TORUS);
       ci("pyramide",PYRAMIDE);
       ci("cylinder",CYLINDER);
       ci("cone",CONE);
       ci("sphere",SPHERE);
       ci("disk",DISK);
       ci("triangle",POLY);
       ci("plane",PLANE);
       ci("Omni",OMNILIGHT); }
      /* else if(in>=LINE&&in<OMNILIGHT){
       instrs=new Image[5];
       ci("Line",0);
       ci("Rect",1);
       ci("Circle",2);
       ci("Ellipse",3);
       ci("Text",4);
       }*/
       else if(in>OMNILIGHT){
       instrs=new Image[2];
       ci("Omni",0);
       ci("TargetL",1);
      // ci("Spot",2);
       }
       /*else if(in>=FREECAM){
       instrs=new Image[2];
       ci("FreeCam",0);
       ci("TargetCam",1);
       }*/
       }
    String inmode=null;
       if(in<=OMNILIGHT){
           itmp=0;
           inmode=Statics.russian?"Геометрия":"Primitives";
       }
       /*else if(in>=LINE&&in<OMNILIGHT){
           itmp=LINE;
           inmode="Сплайны";
       }*/
       else if(in>OMNILIGHT){
           itmp=OMNILIGHT;
           inmode=Statics.russian?"Освещение":"Illumination";
       }
       /*else if(in>=FREECAM){
           itmp=FREECAM;
           inmode="Камеры";
       }*/
       if (in == BOX) drawArray( Create.box(new Vertex(-500, -900, -500), new Vertex(500, 100, 500), 21760),0);
    else if (in == TORUS) drawArray( Create.torus(new Vertex(0, -500, 0), 1000, 200, 15, 15, 21760),true,0);
    else if (in == PYRAMIDE) drawArray( Create.pyramid(new Vertex(0, -800, 0), new Vertex(-700, -800, 700), 1000, 21760),0);
    else if (in == CYLINDER) drawArray( Create.cylinder(new Vertex(0,-800,0),700, 1000, 30, 21760),0);
    else if (in == CONE) drawArray(Create.cone(new Vertex(0,-800,0), 700, 1000, 30, 21760),0);
    else if (in == SPHERE){
        drawArray(Create.sphere(new Vertex(0,-500,0), 700, 10,10, 21760),0);
    }
    else if (in == DISK) drawArray( Create.disk(new Vertex(0,-500,0),1000, 30, 21760),false,0);
    else if (in == PLANE) drawArray(Create.plane(new Vertex(-700,-500,700), new Vertex(700,-500,-700), 21760),false,0);
    else if (in == OMNILIGHT){ drawFlatArray( Create.pyramid(new Vertex(0, -400, 0), new Vertex(-150, -400, 150), -500, 0xdddd00));
    drawFlatArray( Create.pyramid(new Vertex(0, -400, 0), new Vertex(-150, -400, 150), 500, 0xdddd00));
    }
    int j = 5; int k = sh*2 + 5;
    for (int i = 0; i < instrs.length; i++) {
        if(instrs[i]!=null)g.drawImage(instrs[i], j, k, 20);
      if (in == i+itmp){
        g.setColor(0xff0000);
        g.drawRect(j+1, k+1, (Statics.bigImages?58:28), (Statics.bigImages?58:28));
      }
      else g.setColor(0xcccccc);
      g.drawRect(j, k, (Statics.bigImages?60:30), (Statics.bigImages?60:30));
      j += (Statics.bigImages?65:35);
      if (j + (Statics.bigImages?60:30) > w) {
        j = 5;
        k += (Statics.bigImages?65:35);
      }
    }
    g.setFont(Statics.font);
    drawRightSoft("Ok");
    g.setColor(Statics.textColor);
    g.drawString(innames[in], w / 2, sh+1, 17);
    //g.drawString("<1", 3, 1, 20);
    //g.drawString("3>", w-3, 1, Graphics.TOP|Graphics.RIGHT);
    g.drawString(inmode, w/2, 1, 17);
    iy += 5;
    if(iy>360)iy-=360;
    }
  
   //метод при нажатии клавиш
  protected void keyPressed(int key){
      if(modem==10){ //дубликаты
          int gkey=getGameAction(key);
          if(gkey==UP){cDupl++;}
          else if(gkey==DOWN){if(cDupl>1)cDupl--;}
          else if(gkey==FIRE){ duplicate(); modem=0; render(); draw();}
                   String strCode = null;
    try {
      strCode = getKeyName(key).toLowerCase();
    }
    catch (IllegalArgumentException e) {
    }
    if (strCode != null)
    {
      if (((("soft1".equals(strCode)) || ("soft 1".equals(strCode)) || ("soft_1".equals(strCode)) || ("softkey 1".equals(strCode)) || ("sk2(left)".equals(strCode)) || (strCode.startsWith("left soft"))))  
        ){ duplicate();modem=0; render(); draw();}
      if (("soft2".equals(strCode)) || ("soft 2".equals(strCode)) || ("soft_2".equals(strCode)) || ("softkey 4".equals(strCode)) || ("sk1(right)".equals(strCode)) || (strCode.startsWith("right soft"))){
        act=0;modem=0;render(); draw();
      }
    }
     switch (key)
    {
    case -202:
    case -21:
    case -6:
    case 21:
    case 105:
    case 113:
    case 57345:
      duplicate();modem=0; render(); draw(); break;
    case -203:
    case -22:
    case -7:
    case 22:
    case 106:
    case 112:
    case 57346:
      act=0;modem=0;render(); draw(); break;
      }
      }
      else if(modem==9){ // выбор по списку
          String strCode = null;
          try {
      strCode = getKeyName(key).toLowerCase();
    }
    catch (IllegalArgumentException e) {
    }
    if (strCode != null)
    {
      if (((("soft1".equals(strCode)) || ("soft 1".equals(strCode)) || ("soft_1".equals(strCode)) || ("softkey 1".equals(strCode)) || ("sk2(left)".equals(strCode)) || (strCode.startsWith("left soft"))))  
        ){if(act==0){act=2; } else{if(act==1)sel=null; else{sel=null; sel=new Vector(); for(int i=0; i<m.g.size();i++)sel.addElement(m.g.elementAt(i));  } act=0; } render(); draw(); return; }
      if (("soft2".equals(strCode)) || ("soft 2".equals(strCode)) || ("soft_2".equals(strCode)) || ("softkey 4".equals(strCode)) || ("sk1(right)".equals(strCode)) || (strCode.startsWith("right soft"))){
        if(act==0){modem=4;
        select=null;
        }else{/*if(act==1)sel=null; else{sel=null; sel=new Vector(); for(int i=0; i<m.g.size();i++)sel.addElement(m.g.elementAt(i));  }*/ act=0; }
      render(); draw();
      return;
      }
    }
     switch (key)
    {
    case -202:
    case -21:
    case -6:
    case 21:
    case 105:
    case 113:
    case 57345:if(act==0){act=2; } else{if(act==1)sel=null; else{sel=null; sel=new Vector(); for(int i=0; i<m.g.size();i++)sel.addElement(m.g.elementAt(i));  } act=0; } render(); draw(); break;
    case -203:
    case -22:
    case -7:
    case 22:
    case 106:
    case 112:
    case 57346:
      if(act==0){modem=4;
        select=null;
        }else{/*if(act==1)sel=null; else{sel=null; sel=new Vector(); for(int i=0; i<m.g.size();i++)sel.addElement(m.g.elementAt(i));  }*/ act=0; }
      render(); draw();
      break;
      }
          int ga=getGameAction(key);
          switch(ga){
              case UP: if(act==0)select.up(); else{ if(act==1)act=2; else act=1;}break;
              case FIRE: if(act==0){
                  if(sel==null)sel=new Vector();
                  int mll=(m.l==null?0:m.l.size());
                  Object ob;
                  if(select.index<mll/*&&select.index>=0*/)ob=m.l.elementAt(select.index);
                  else ob=m.g.elementAt(select.index-mll);
                  if(!sel.contains(ob))
                      sel.addElement(ob);
                  else sel.removeElement(ob);}
              else{if(act==1)sel=null; else{sel=null; sel=new Vector(); for(int i=0; i<m.g.size();i++)sel.addElement(m.g.elementAt(i));  } act=0; } render(); draw(); break;
              case DOWN: if(act==0)select.down(); else {if(act==1)act=2; else act=1; }break;
          }
      }
      else if(modem==4||modem==3||modem==5){ // выбор режима
          if(key==KEY_NUM0){if((sel==null||sel.isEmpty())&&mode>7&&mode<11&&view==0) mode=4; if((!(modem==4||modem==5)&&view!=0)||view==0)modem=0;draw();}
          int ga=getGameAction(key);
          switch(ga){
              case RIGHT: mode++;break;
              case LEFT: mode--;break;
              case FIRE: if(view==0&&((sel!=null&&!sel.isEmpty()&&Edit.mo==0)||(sel2!=null&&!sel2.isEmpty()&&Edit.mo==1)||(sel3!=null&&!sel3.isEmpty()&&Edit.mo==2))){if(mode==8){act=1;ex0=ey0=ez0=0;} else if(mode==9){act=1;ex=ey=ez=0;} else if(mode==10){act=1;exs=eys=ezs=1;} modem=0; draw();} else if((view==0&&mode<7||view!=0&&mode<4&&mode!=1)&&mode!=7){modem=0; draw();} if(mode==7){toSelectionMenu();}break;
              case DOWN: if(modem==3){modem=4;mode=4;} else if(modem==4){modem=5;mode=8;}break;
              case UP: if(modem==4){ modem=3;mode=0;} else if(modem==5){modem=4;mode=4;}break;
          }
      }
      else if(modem==2){ // меню шэйдинга и просмотра
          int ga=getGameAction(key);
          switch(ga){
              case UP: shad.up();break;
              case DOWN: shad.down();break;
              case FIRE: if(shad.index<4) view=(short)shad.index; else if(shad.index>4)shading=shad.index-5;shad=null;modem=0;render();draw();break;
          }
      }
      else if(modem==1){ // инструменты
      int itmp=0;
      String strCode = null;
                if(in<=OMNILIGHT){
           itmp=0;
       }
       /*else if(in>=LINE&&in<OMNILIGHT){
           itmp=LINE;
       }*/
       else if(in>OMNILIGHT){
           itmp=OMNILIGHT;
       }
      /* else if(in>=FREECAM){
           itmp=FREECAM;
       }*/
                    if (strCode != null)
    {
          if (("soft2".equals(strCode)) || ("soft 2".equals(strCode)) || ("soft_2".equals(strCode)) || ("softkey 4".equals(strCode)) || ("sk1(right)".equals(strCode)) || (strCode.startsWith("right soft"))){
         instr=instrs[in-itmp];instrs=null;System.gc();mode = 0; modem=0; act = 0;render();draw();}
    }
                    switch(key){
    case -203:
    case -22:
    case -7:
    case 22:
    case 106:
    case 112:
    case 57346:
       instr=instrs[in-itmp];instrs=null;System.gc();mode = 0; modem=0; act = 0;render();draw();break;
    case 49:           //instrs=null;
          /*if(in>=LINE&&in<OMNILIGHT)in=0;
          else if(in>=OMNILIGHT&&in<FREECAM)in=LINE;
          else if(in>=FREECAM)in=OMNILIGHT;*/
    //if (in>OMNILIGHT) in=0;break;
    case 51:           //instrs=null;
          /*if(in<LINE)in=LINE;
          else if(in>=LINE&&in<OMNILIGHT)in=OMNILIGHT;
          else if(in>=OMNILIGHT&&in<FREECAM)in=FREECAM;*/
    //if(in<OMNILIGHT)in=OMNILIGHT;
    break;
                    }
     int ga = getGameAction(key);
     int pl;
      switch (ga) {
      case LEFT:
        in -= 1;if(in<itmp) in=(short)(instrs.length+itmp-1); break;
      case RIGHT:
        in += 1;if(in==instrs.length+itmp) in=(short)itmp; break;
      case FIRE:
        instr=instrs[in-itmp];instrs=null;System.gc();mode = 0;modem=0; act = 0;render();draw();break;
      case DOWN: pl=(w-5)/(Statics.bigImages?65:35); if(in-itmp+pl<instrs.length) in+=pl; break;
      case UP: pl=(w-5)/(Statics.bigImages?65:35); if(in-itmp-pl>=0) in-=pl;break;
      }
      }
      
      
      else{ // рабочее место
         String strCode = null;
    
    try {
      strCode = getKeyName(key).toLowerCase();
    }
    catch (IllegalArgumentException e) {
    }
    if (strCode != null)
    {
      if (((("soft1".equals(strCode)) || ("soft 1".equals(strCode)) || ("soft_1".equals(strCode)) || ("softkey 1".equals(strCode)) || ("sk2(left)".equals(strCode)) || (strCode.startsWith("left soft")))))
      {modem = 1; return; }
      if (("soft2".equals(strCode)) || ("soft 2".equals(strCode)) || ("soft_2".equals(strCode)) || ("softkey 4".equals(strCode)) || ("sk1(right)".equals(strCode)) || (strCode.startsWith("right soft")))
      { back(); return; }
    }
     switch (key)
    {
    case -202:
    case -21:
    case -6:
    case 21:
    case 105:
    case 113:
    case 57345:
      modem = 1; break;
    case -203:
    case -22:
    case -7:
    case 22:
    case 106:
    case 112:
    case 57346:
      back(); break;
    case 53:
      if (mode == 0) fire();
      if(mode==4) pick(cur.sx,cur.sy);
      if(mode==5)
          if(selact){if(Edit.mo==0)sel=m.select(curselx,cursely,cur.sx,cur.sy,n); else if(Edit.mo==1)sel2=m.selectTr(curselx,cursely,cur.sx,cur.sy); else if(Edit.mo==2) sel3=m.selectVer(curselx,cursely,cur.sx,cur.sy);
          showNotify();
          selact=false;}
          else{curselx=cur.sx;cursely=cur.sy; selact=true;}
      if(mode==6)
          if(selact){if(Edit.mo==0)sel=m.select3d(new int[]{curselx,cursely,curselz,cur.x,cur.y,cur.z}, n); else if(Edit.mo==1)sel2=m.select3dTr(new int[]{curselx,cursely,curselz,cur.x,cur.y,cur.z}); else if(Edit.mo==2)sel3=m.select3dVer(new int[]{curselx,cursely,curselz,cur.x,cur.y,cur.z});
          showNotify();
          selact=false;}
          else{curselx=cur.x;cursely=cur.y; curselz=cur.z; selact=true;}
      if(mode>7&&mode<11)
          if(act==1){
              act=0;
              if(starPressed){
              modem=10;cDupl=1;} else if(Edit.mo==0){
              for(int i=0;i<sel.size();i++){
                  if(sel.elementAt(i) instanceof Light){
                      if(mode!=8)continue;
                      ((Light)sel.elementAt(i)).x+=ex0;
                      ((Light)sel.elementAt(i)).y+=ey0;
                      ((Light)sel.elementAt(i)).z+=ez0;
                  }
                  else soequal((Group)sel.elementAt(i));
              }
              }
          else if(Edit.mo==1){soequalTri();}
          else if(Edit.mo==2){soequalVer();}}
          else{if(mode==8){act=1;ex0=ey0=ez0=0;} else if(mode==9){act=1;ex=ey=ez=0;} else if(mode==10){act=1;exs=eys=ezs=1;}}
      if(act==0)render();draw(); break;
    case 48:
          if(mode<4)
              modem=3;
          else if(mode>3&&mode<8){selact=false; modem=4;}
          else modem=5;
          if(act==1&&mode>=8&&mode<=10){ act=0;render();draw();}
      break;
    case 55:    modem=2;
      shad=new Menu(new String[]{Statics.russian?"Перспектива":"Perspective",Statics.russian?"сверху":"top",Statics.russian?"справа":"right",Statics.russian?"спереди":"front","--------",Statics.russian?"полигоны":"polygons",Statics.russian?"сглаживание":"smooth",Statics.russian?"плоское":"flat",Statics.russian?"ребра":"wires",Statics.russian?"описанные боксы":"Bounding boxes"},Statics.font);
      shad.textColor=0xeeeaec;
      shad.selTextColor=0xaaa6a8;
      shad.curColor=0xffffff;
      shad.ave=new short[]{4};break;
    case KEY_STAR: if(mode>=8&&mode<=10||mode==4) starPressed=true; 
    }
        if(mode==0&&key>48&&key<58)sk((short)key);else km=(short)key;}
  }
  
  protected void keyRepeated(int key){
      hold=true;
      if(key==KEY_STAR&&mode==0)Main.main.toMatEd();
          if(key==57)Main.main.saveScreen(buf);
      if(modem==0&&key==55){
      modem=2;
      shad=new Menu(new String[]{Statics.russian?"Перспектива":"Perspective",Statics.russian?"сверху":"top",Statics.russian?"справа":"right",Statics.russian?"спереди":"front","--------",Statics.russian?"полигоны":"polygons",Statics.russian?"сглаживание":"smooth",Statics.russian?"плоское":"flat",Statics.russian?"ребра":"wires",Statics.russian?"описанные боксы":"Bounding boxes"},Statics.font);
      shad.textColor=0xeeeaec;
      shad.selTextColor=0xaaa6a8;
      shad.curColor=0xffffff;
      shad.ave=new short[]{4};}
      if(modem==0&&mode==0)km=(short)key;
  }
  
  protected void keyReleased(int key){
      km=0;
      if(key==KEY_STAR){ starPressed=false; if(mode==0&&!hold){ Main.main.toColor(); Main.main.color.setColor(color);}}
      if(modem==0&&act==0&&key==57&&!hold)Main.main.toEdit();
      hold=false;
  }
  
  protected void pointerPressed(int xp,int yp){
      if(modem==10){
          if(xp<=w/2+30&&xp>=w/2-30){
              if(yp>=h/4-30&&yp<=h/4+30){cDupl++;}
              else if(yp>=h-h/4-30&&yp<=h-h/4+30){if(cDupl>1)cDupl--;}
          }
          else if(yp>=h-40){
              if(xp<=w/4){duplicate();modem=0; render(); draw();}
              else if(xp>=w-w/4){act=0;modem=0; render(); draw();}
          }
      }
      else if(modem==9){
          if(act==0){
          if(yp>=h-40&&xp>=w-w/4){
              modem=4;
              select=null;
          }
          else{
              xs=xp;
              ys=yp;
          }
          }
          else{
              xs=xp;
              ys=yp;
              if(xp<=Statics.font.stringWidth(Statics.russian?"Выбрать все":"Select all")){
                      if(yp>=h-select.sh){
                          act=1;
                      }
                      else if(yp>=h-select.sh*2){
                          act=2;
                      }
                  }
          }
      }
      else if(modem==3||modem==4||modem==5){
          if(yp>=h-(Statics.bigImages?60:30)&&xp<=(Statics.bigImages?65:35)*(modem==5?3:4)+3){
              short imode=(short)((xp-3)/(Statics.bigImages?65:35)+(modem==4?4:(modem==5?8:0)));
              if(mode==imode){if(view==0&&((sel!=null&&!sel.isEmpty()&&Edit.mo==0)||(sel2!=null&&!sel2.isEmpty()&&Edit.mo==1)||(sel3!=null&&!sel3.isEmpty()&&Edit.mo==2))){if(mode==8){act=1;ex0=ey0=ez0=0;} else if(mode==9){act=1;ex=ey=ez=0;} else if(mode==10){act=1;exs=eys=ezs=1;} modem=0; draw();} else if((view==0&&mode<7||view!=0&&mode<4&&mode!=1)&&mode!=7){modem=0; draw();} if(mode==7){toSelectionMenu();}} else mode=imode;
          }
          else if(yp<=h-(Statics.bigImages?60:30)&&yp>=h-(Statics.bigImages?60:30)-40){
              if(xp>=w/2&&modem!=5)modem++;
              else if(xp<=w/2&&modem!=3)modem--;
          }
      }
      else if(modem==2){
          if(xp<=shad.f.stringWidth(Statics.russian?"описанные боксы":"Bounding boxes")){
              int shi=shad.getTouchIndex(yp);
              if(shi!=0xffffff)shad.index=shi;
          }
          else modem=0;
      }
      else if(modem==1){
          if(yp>=h-40&&xp>=w-40){ instr=instrs[in];instrs=null;System.gc();mode = 0; modem=0; act = 0;render();draw(); }
          else if(yp>Statics.font.getHeight()*2){
          int wiw=(w-5)/(Statics.bigImages?65:35);
          int imod=(xp-5)/(Statics.bigImages?65:35)+(yp-Statics.font.getHeight()*2-5)/(Statics.bigImages?65:35)*wiw;
          if(imod<=OMNILIGHT&&imod>=0){if(in==imod){instr=instrs[in];instrs=null;System.gc();mode = 0;modem=0; act = 0;render();draw();} else in=(short)imod;}
          }
      }
      else if(modem==0){
          if(xp<=w/2+(Statics.bigImages?35:20)&&xp>=w/2-(Statics.bigImages?35:20)&&yp>=h-(Statics.bigImages?60:30)){if(mode<4)modem=3;else if(mode>=4&&mode<8)modem=4; else if(mode>7)modem=5; }
          else if(xp>=w-(Statics.bigImages?60:30)&&yp<=(Statics.bigImages?60:30))modem=1;
          else if((mode>=8||mode==4)&&yp>=h-80&&xp>=w-w/4&&yp<=h-40)starPressed=!starPressed;
          else if(xp>=w-(Statics.bigImages?123:63)&&xp<=w-(Statics.bigImages?60:30)&&yp<=(Statics.bigImages?60:30)){
          if(mattimer!=null){
          mattimer.cancel();
          mattimer=null;
      }
          mattimer=new Timer();
      TimerTask mt=new TimerTask(){
          public void run(){
              Main.main.toMatEd();
          }
      };
      mattimer.schedule(mt, 1000);
          }
          else if(xp<=(Statics.bigImages?60:30)&&yp<=(Statics.bigImages?60:30)){
              modem=2;
      shad=new Menu(new String[]{Statics.russian?"Перспектива":"Perspective",Statics.russian?"сверху":"top",Statics.russian?"справа":"right",Statics.russian?"спереди":"front","--------",Statics.russian?"полигоны":"polygons",Statics.russian?"сглаживание":"smooth",Statics.russian?"плоское":"flat",Statics.russian?"ребра":"wires",Statics.russian?"описанные боксы":"Bounding boxes"},Statics.font);
      shad.textColor=0xeeeaec;
      shad.selTextColor=0xaaa6a8;
      shad.curColor=0xffffff;
      shad.ave=new short[]{4};}
          else if(yp>=h-40){
              if(xp<=40){if(mode>=8&&act==1){
                  act=0;
                  if(starPressed){modem=10;cDupl=1;}
                  else if(Edit.mo==0){
                      for(int i=0;i<sel.size();i++){
                  if(sel.elementAt(i) instanceof Light){
                      if(mode!=8)continue;
                      ((Light)sel.elementAt(i)).x+=ex0;
                      ((Light)sel.elementAt(i)).y+=ey0;
                      ((Light)sel.elementAt(i)).z+=ez0;
                  }
                         else soequal((Group)sel.elementAt(i));}}
                  else if(Edit.mo==1){
                      soequalTri();} 
                  else if(Edit.mo==2){soequalVer();}} 
              else Main.main.toEdit();}
              else if(xp>=w-40)back();
          }
          else{
              xs=xp;
              ys=yp;
              if(mode==0){
              int[] unpr=Vertex.unProject(n, xp, yp);
              if(in==POLY){
                  if(act==0){
                gr=new Group(null,"Object",m.g==null||m.g.isEmpty()?0:m.g.size());
            act=2;
          if(Statics.randColor)color=(new Random()).nextInt(0xffffff);
            ver1=new Vertex(unpr[0],0,unpr[1]);
            }
            else if(act==1){
                act=2;
          if(Statics.randColor)color=(new Random()).nextInt(0xffffff);
                ver1=new Vertex(unpr[0],0,unpr[1]);
            }
            else if(act==2){
                act=3;
                ver2=new Vertex(unpr[0],0,unpr[1]);
            }
            else if(act==3){
                act=1;
                Triangle tr=new Triangle(new Vertex(ver1),new Vertex(ver2),new Vertex(unpr[0],0,unpr[1]),color);
                tr.norm();
                tr.smooth=false;
                tr.setMatrix(n);
                if(tr.rnz>0){tr.nz*=-1;tr.nx*=-1;tr.ny*=-1;}
                gr.add(tr);
    }
            return;
              }
              if(act==0)ver1 = new Vertex(unpr[0],0,unpr[1]);
              if(Statics.randColor)color=(new Random()).nextInt(0xffffff);
              act=1;
              }
              else if(mode>0&&mode<4){
                      curselx=xp;
                      cursely=yp;
              }
              else if(mode==4){
                  pick(xp,yp);
                  render();
                  draw();
              }
              else if(mode==5){
                  selact=true;
                  curselx=xp;
                  cursely=yp;
              }
              else if(mode==6){
                  int[] unpr=Vertex.unProject(n, xp, yp);
                  ver1 = new Vertex(unpr[0],0,unpr[1]);
                  selact=true;
              }
              else if(mode>=8){
                  if(act==0){
                      act=1;
                      if(mode==8){ex0=ey0=ez0=0;} else if(mode==9){ex=ey=ez=0;} else if(mode==10){exs=eys=ezs=1;}
                  }
                  else if(act==1){
                      curselx=xp;
                      cursely=yp;
                  }
              }
          }
      }
  }
  
  protected void pointerDragged(int xp,int yp){
      if(modem==0){
          xs=xp;
          ys=yp;
          if(mode==1){
              x+=yp-cursely;
              y-=xp-curselx;
              curselx=xp;
              cursely=yp;
          }
          else if(mode==2){
              xo+=(xp-curselx)*10;
              yo-=(yp-cursely)*10;
              curselx=xp;
              cursely=yp;
          }
          else if(mode==3){
              dist+=(yp-cursely)*20;
              curselx=xp;
              cursely=yp;
          }
          else if(mode==8){
              if(curselx<=w/3){
                  ex0-=(yp-cursely)*10;
              }
              else if(curselx<=w*2/3&&curselx>w/3){
                  ey0-=(yp-cursely)*10;
              }
              else{
                  ez0-=(yp-cursely)*10;
              }
              cursely=yp;
          }
          else if(mode==9){
              if(curselx<=w/3){
                  ex+=(yp-cursely);
              }
              else if(curselx<=w*2/3&&curselx>w/3){
                  ey+=(yp-cursely);
              }
              else{
                  ez+=(yp-cursely);
              }
              cursely=yp;
          }
          else if(mode==10){
              if(curselx<=w/3){
                  if(yp<cursely)
                  exs*=1.02f;
                  else exs/=1.02;
              }
              else if(curselx<=w*2/3&&curselx>w/3){
                  if(yp<cursely)
                  eys*=1.02f;
                  else eys/=1.02;
              }
              else{
                  if(yp<cursely)
                  ezs*=1.02f;
                  else ezs/=1.02;
              }
              cursely=yp;
          }
          if(mode<4||mode>7)render();
          draw();
      }
      else if(modem==2){
          int shi=shad.getTouchIndex(yp);
          if(shi!=0xffffff)shad.index=shi;
      }
      else if(modem==9){
          select.move(yp-ys);
          ys=yp;
      }
  }
  
  protected void pointerReleased(int xp,int yp){
      if(modem==0){
          if(xp>=w-(Statics.bigImages?123:63)&&xp<=w-(Statics.bigImages?60:30)&&yp<=(Statics.bigImages?60:30)&&mattimer!=null){
              if(mattimer!=null){
          mattimer.cancel();
      }
          mattimer=null;
              Main.main.toColor(); Main.main.color.setColor(color);}
      if(mode==0&&act==1){
          if(in==POLY)return;
          act=0;
          if (in == BOX){
        int vrx=(int)Math.sqrt((ver1.sx-xs)*(ver1.sx-xs)+(ver1.sy-ys)*(ver1.sy-ys))*10;
      m.add( Create.box(new Vertex(ver1.x-vrx,ver1.y-vrx,ver1.z-vrx),new Vertex(ver1.x+vrx,ver1.y+vrx,ver1.z+vrx) , color),"box");}
    else if (in == TORUS){
        m.add(Create.torus(ver1, Math.abs(ver1.sx-xs)*10,Math.abs(ver1.sy-ys)*10, 20, 10, color),"torus");
    }
    else if (in == PYRAMIDE){
        m.add(Create.pyramid(ver1, new Vertex(ver1.x+Math.abs(ver1.sx-xs)*10,ver1.y,ver1.z+Math.abs(ver1.sx-xs)*10), (ver1.sy-ys)*10, color),"pyramid");
    }
    else if (in == CYLINDER) m.add( Create.cylinder(ver1,Math.abs(ver1.sx-xs)*10, (ver1.sy-ys)*10, 30, color),"cylinder");
    else if (in == CONE) m.add( Create.cone(ver1, Math.abs(ver1.sx-xs)*10, (ver1.sy-ys)*10, 30, color),"cone");
    else if( in == SPHERE)m.add( Create.sphere(ver1, Math.sqrt((ver1.sx-xs)*(ver1.sx-xs)+(ver1.sy-ys)*(ver1.sy-ys))*10, 20, 20, color),"sphere");
    else if(in==DISK){
        m.add(Create.disk(ver1,Math.sqrt((ver1.sx-xs)*(ver1.sx-xs)+(ver1.sy-ys)*(ver1.sy-ys))*10, 30, color),"disk");
    }
    else if(in==POLY){
        /*gr.draw(g, n,null);
        g.setColor(color);
        if(act==2){g.drawLine(ver1.sx, ver1.sy, cur.sx, cur.sy);}
        if(act==3) g.fillTriangle(ver1.sx, ver1.sy, ver2.sx, ver2.sy, cur.sx, cur.sy);
    */}
    else if(in==PLANE){
        m.add(Create.plane(new Vertex(ver1.x-Math.abs(ver1.sx-xs)*10,ver1.y,ver1.z-Math.abs(ver1.sy-ys)*10), new Vertex(ver1.x+Math.abs(ver1.sx-xs)*10,ver1.y,ver1.z+Math.abs(ver1.sy-ys)*10), color),"plane");
    }
    else if(in==OMNILIGHT){
        if(m.l==null){
            m.l=new Vector();
        }
        m.l.addElement(new Light(ver1));
        sel=new Vector();
        sel.addElement(m.l.lastElement());
    }
            if(in!=OMNILIGHT){
                m.getLast().countBoundary();
            centerX=m.getLast().ax;
            centerY=m.getLast().ay;
            centerZ=m.getLast().az;
            sel=null;
            System.gc();
            sel=new Vector();
            sel.addElement(m.getLast());
            }
          ver1=null;
      }
      else if(mode==5){
          if(Edit.mo==0)sel=m.select(curselx,cursely,xs,ys,n); else if(Edit.mo==1)sel2=m.selectTr(curselx,cursely,xs,ys); else if(Edit.mo==2) sel3=m.selectVer(curselx,cursely,xs,ys);
          showNotify();
          selact=false;
      }
      else if(mode==6){
          int vrx;
          if(ver1!=null){vrx=(int)Math.sqrt((ver1.sx-xs)*(ver1.sx-xs)+(ver1.sy-ys)*(ver1.sy-ys))*10;
          if(Edit.mo==0)sel=m.select3d(new int[]{ver1.x-vrx,ver1.y-vrx,ver1.z-vrx,ver1.x+vrx,ver1.y+vrx,ver1.z+vrx}, n); else if(Edit.mo==1)sel2=m.select3dTr(new int[]{ver1.x-vrx,ver1.y-vrx,ver1.z-vrx,ver1.x+vrx,ver1.y+vrx,ver1.z+vrx}); else if(Edit.mo==2)sel3=m.select3dVer(new int[]{ver1.x-vrx,ver1.y-vrx,ver1.z-vrx,ver1.x+vrx,ver1.y+vrx,ver1.z+vrx});
          }
      showNotify();
          selact=false;
          ver1=null;
      }
          render();
          draw();
  }
      else if(modem==2){
          int shi=shad.getTouchIndex(yp);
          if(shi==shad.index){
              if(shi<4)view=(short)shi;
          else if(shi>4)shading=shi-5;
              modem=0;
              render();
              draw();
              shad=null;
          }
      }
      else if(modem==9){
          if(act==0){
          if(xp==xs&&yp==ys){
              if(yp>=h-40&&xp<=w/4){ act=2; }
              else{
              int shi=select.getTouchIndex(yp);
              if(shi!=0xffffff){
                  if(sel==null)sel=new Vector();
                  Object addobj;
                  if(m.l!=null&&shi<m.l.size())
                      addobj=m.l.elementAt(shi);
                  else addobj=m.g.elementAt(shi-(m.l==null?0:m.l.size()));
                  if(!sel.contains(addobj))
                  sel.addElement(addobj);
                  else sel.removeElement(addobj);
              }
          }
          }
          }
          else{
              if(xp==xs&&yp==ys&&xp<=Statics.font.stringWidth(Statics.russian?"Выбрать все":"Select all")){
                      if(yp>=h-select.sh&&act==1){
                          act=0; sel=null; render(); draw();
                      }
                      else if(yp>=h-select.sh*2&&act==2){
                           sel=null; sel=new Vector();
                           for(int i=0; i<m.g.size();i++)
                               sel.addElement(m.g.elementAt(i));
                           act=0;
                      render(); draw();
                      }
                  }
          }
      }
          
  }
  
  public void toSelectionMenu(){
      if((m.g==null||m.g.isEmpty())&&(m.l==null||m.l.isEmpty()))return;
      modem=9;
      act=0;
      int mll=(m.l!=null?m.l.size():0);
      String[] selarray=new String[m.g.size()+mll];
      for(int i=0;i<selarray.length;i++){
          if(i<mll) selarray[i]=(i+1)+". Omnilight";
          else selarray[i]=(i+1)+". "+((Group)m.g.elementAt(i-mll)).name;}
      select=new Menu(selarray,Statics.font);
      select.textColor=Statics.textColor;
  }
  
  protected void showNotify(){ // при отображении редактора перерассчитывается центр группы выделенных объектов, вокруг которого она будет вращаться или масштабироваться, так удобно
      if(Edit.mo==0){
          if(sel!=null&&!sel.isEmpty()){
              centerX=centerY=centerZ=0;
              int count=0;
              for(int i=0;i<sel.size();i++){
                  if(!(sel.elementAt(i) instanceof Group))continue;
                  Group gro=(Group)sel.elementAt(i);
                  centerX=centerX+gro.ax;
                  centerY=centerY+gro.ay;
                  centerZ=centerZ+gro.az;
                  count++;
              }
              if(count!=0){
              centerX/=count;
              centerY/=count;
              centerZ/=count;}
          }
      }
      else if(Edit.mo==1){
          if(sel2!=null&&!sel2.isEmpty()){
              centerX=centerY=centerZ=0;
              for(int i=0;i<sel2.size();i++){
                  Triangle t=(Triangle)sel2.elementAt(i);
                  centerX=centerX+((t.a.x+t.b.x+t.c.x)/3);
                  centerY=centerY+((t.a.y+t.b.y+t.c.y)/3);
                  centerZ=centerZ+((t.a.z+t.b.z+t.c.z)/3);
              }
              centerX/=sel2.size();
              centerY/=sel2.size();
              centerZ/=sel2.size();
          }
      }
      else if(Edit.mo==2){
          if(sel3!=null&&!sel3.isEmpty()){
              centerX=centerY=centerZ=0;
              for(int i=0;i<sel3.size();i++){
                  Vertex t=(Vertex)sel3.elementAt(i);
                  centerX+=t.x;
                  centerY+=t.y;
                  centerZ+=t.z;
              }
              centerX/=sel3.size();
              centerY/=sel3.size();
              centerZ/=sel3.size();
          }
      }
  }
  
  public void pick(int xp,int yp){ // выделение ближайшего объекта
      if(Edit.mo==0){
      Object ogr=m.pick(xp, yp, n);
      if(ogr==null){if(!starPressed){sel=null; System.gc();}return;}
      if(starPressed){if(sel==null){sel=new Vector(); centerX=centerY=centerZ=0;}
          if(!sel.contains(ogr)){
              if(ogr instanceof Group){
              gr=(Group)ogr;
          centerX=(centerX*sel.size()+gr.ax)/(sel.size()+1);
          centerY=(centerY*sel.size()+gr.ay)/(sel.size()+1);
          centerZ=(centerZ*sel.size()+gr.az)/(sel.size()+1);}
          sel.addElement(ogr);
          }
          else{
              if(sel.size()==1){
                  centerX=centerY=centerZ=0;
              }
              else{
          if(ogr instanceof Group){
              gr=(Group)ogr;
            centerX=(centerX*sel.size()-gr.ax)/(sel.size()-1);
            centerY=(centerY*sel.size()-gr.ay)/(sel.size()-1);
            centerZ=(centerZ*sel.size()-gr.az)/(sel.size()-1);
              }
          sel.removeElement(ogr);
          }
          }
      }
      else{
      sel=new Vector();
      sel.addElement(ogr);
      if(ogr instanceof Group){
          gr=(Group)ogr;
      centerX=gr.ax;
      centerY=gr.ay;
      centerZ=gr.az;}
      }
      }
      else if(Edit.mo==1){
          Triangle tr=m.pickTr(xp,yp, n);
          if(tr==null){ if(!starPressed){ sel2=null; System.gc();}return;}
          else{
              if(starPressed){
                  if(sel2==null){ sel2=new Vector(); centerX=centerY=centerZ=0;}
                  if(!sel2.contains(tr)){ 
                  int trax=(tr.a.x+tr.b.x+tr.c.x)/3,tray=(tr.a.y+tr.b.y+tr.c.y)/3,traz=(tr.a.z+tr.b.z+tr.c.z)/3;
                  centerX=(centerX*sel2.size()+trax)/(sel2.size()+1);
                  centerY=(centerY*sel2.size()+tray)/(sel2.size()+1);
                  centerZ=(centerZ*sel2.size()+traz)/(sel2.size()+1);
                      sel2.addElement(tr);}
                  else{
                      if(sel2.size()==1){
                          centerX=centerY=centerZ=0;
                      }
                      else{
                  int trax=(tr.a.x+tr.b.x+tr.c.x)/3,tray=(tr.a.y+tr.b.y+tr.c.y)/3,traz=(tr.a.z+tr.b.z+tr.c.z)/3;
                  centerX=(centerX*sel2.size()-trax)/(sel2.size()-1);
                  centerY=(centerY*sel2.size()-tray)/(sel2.size()-1);
                  centerZ=(centerZ*sel2.size()-traz)/(sel2.size()-1);}
                      sel2.removeElement(tr);}
              }
              else{
                  sel2=new Vector();
                  sel2.addElement(tr);
                  centerX=(tr.a.x+tr.b.x+tr.c.x)/3;
                  centerY=(tr.a.y+tr.b.y+tr.c.y)/3;
                  centerZ=(tr.a.z+tr.b.z+tr.c.z)/3;
              }
          }
      }
      else if(Edit.mo==2){
          Vertex ver=m.pickVer(xp, yp);
          if(ver==null){ if(!starPressed){sel3=null; System.gc();}return;}
          else{
              if(starPressed){
                  if(sel3==null){sel3=new Vector(); centerX=centerY=centerZ=0;}
                  if(!sel3.contains(ver)){
                  centerX=(centerX*sel3.size()+ver.x)/(sel3.size()+1);
                  centerY=(centerY*sel3.size()+ver.y)/(sel3.size()+1);
                  centerZ=(centerZ*sel3.size()+ver.z)/(sel3.size()+1);
                  sel3.addElement(ver);
                  }
                  else{
                      if(sel3.size()==1)centerX=centerY=centerZ=0;
                      else{
                  centerX=(centerX*sel3.size()-ver.x)/(sel3.size()-1);
                  centerY=(centerY*sel3.size()-ver.y)/(sel3.size()-1);
                  centerZ=(centerZ*sel3.size()-ver.z)/(sel3.size()-1);
                      }
                      sel3.removeElement(ver);
                  }
              }
              else{
                  sel3=new Vector();
                  sel3.addElement(ver);
                  centerX=ver.x;
                  centerY=ver.y;
                  centerZ=ver.z;
              }
          }
      }
  }
  
  public void duplicate(){ // дублировать cDupl-ное количество раз выделенное
      act=0;
      Vertex[] ver;
      for(int jj=0;jj<sel.size();jj++){
          if(!(sel.elementAt(jj) instanceof Group))continue;
          Group sell=(Group)sel.elementAt(jj);
      for(int i=0; i<cDupl;i++){
          Group gro=new Group();
          ver=new Vertex[sell.v.size()];
          gro.name=sell.name.substring(0,sell.name.lastIndexOf('_'))+'_'+(i+1);
          gro.ax=sell.ax;
          gro.ay=sell.ay;
          gro.az=sell.az;
          gro.maxx=sell.maxx;
          gro.maxy=sell.maxy;
          gro.maxz=sell.maxz;
          gro.minx=sell.minx;
          gro.miny=sell.miny;
          gro.minz=sell.minz;
          for (int j=0;j<sell.v.size();j++){
              gro.v.addElement(new Vertex((Vertex)sell.v.elementAt(j)));
              ver[j]=(Vertex)sell.v.elementAt(j);
          }
          for(int j=0;j<sell.f.size();j++){
              Face face=(Face)sell.f.elementAt(j);
              if(face instanceof Triangle){
                  Triangle ft=(Triangle)face;
                  Triangle tr=new Triangle((Vertex)gro.v.elementAt(findVer(ft.a,ver)),(Vertex)gro.v.elementAt(findVer(ft.b,ver)),(Vertex)gro.v.elementAt(findVer(ft.c,ver)),ft.color);
                  tr.nx=ft.nx;
                  tr.ny=ft.ny;
                  tr.nz=ft.nz;
                  tr.smooth=ft.smooth;
                  tr.material=ft.material;
                  tr.uv=ft.uv;
                  gro.f.addElement(tr);
              }
              else if(face instanceof Line){
                  Line l=(Line)face;
                  gro.f.addElement(new Line(l.a,l.b,l.color));
              }
          }
          sell=gro;
          soequal(sell);
          m.g.addElement(sell);
      }
  }
  }
  
  public int findVer(Vertex v,Vertex[] ver){ // просто поиск вершины в массиве
      int k=0;
      for(int i=0;i<ver.length;i++){
          if(v.x==ver[i].x&&v.y==ver[i].y&&v.z==ver[i].z) k=i;
      }
      return k;
  }
  
  public void soequal(Group sell){ // закрепление преобразованной геометрии и перерассчет нормалей, если нужно
      act=0;
      if(mode==8){
          n.unit();
          n.translate(ex0, ey0, ez0);
          sell.soequal(n,0);
          centerX+=ex0;
          centerY+=ey0;
          centerZ+=ez0;
      }else if(mode==9){
          n.unit();
          n.translate(-centerX, -centerY, -centerZ);
          n.yrot(ey);
          n.xrot(ex);
          n.zrot(ez);
          n.translate(centerX, centerY, centerZ);
          sell.soequal(n,1);
      }
      else if(mode==10){
          n.unit();
          n.translate(-centerX, -centerY, -centerZ);
          n.scale(exs, eys, ezs);
          n.translate(centerX, centerY, centerZ);
          sell.soequal(n,2);
          float nx,ny,nz;
                  for (int i=0;i<sell.f.size();i++){
            if(sell.f.elementAt(i) instanceof Triangle){
                Triangle tri=(Triangle)sell.f.elementAt(i);
                nx=tri.nx;
                ny=tri.ny;
                nz=tri.nz;
                tri.norm();
            if(tri.nx*nx<0||tri.ny*ny<0||tri.nz*nz<0) tri.invert();
            }
                  }
      }
          sell.countBoundary();
         // sel.triNorm();
         // sel.verNorm();
  }
  
  private void soequalTri(){
      act=0;
      if(mode==8){
          n.unit();
          n.translate(ex0, ey0, ez0);
          for(int i=0;i<sel2.size();i++){
              Triangle tr=(Triangle)sel2.elementAt(i);
              tr.setVertexMatrix(n);
          }
          for(int i=0;i<sel2.size();i++){
              Triangle tr=(Triangle)sel2.elementAt(i);
              tr.a.soequal();
              tr.b.soequal();
              tr.c.soequal();
          }
      }
      else if(mode==9){
          n.unit();
          n.translate(-centerX, -centerY, -centerZ);
          n.yrot(ey);
          n.xrot(ex);
          n.zrot(ez);
          n.translate(centerX, centerY, centerZ);
          for(int i=0;i<sel2.size();i++){
              Triangle tr=(Triangle)sel2.elementAt(i);
              tr.setVertexMatrix(n);
              tr.setMatrix(n);
          }
          for(int i=0;i<sel2.size();i++){
              Triangle tr=(Triangle)sel2.elementAt(i);
              tr.a.soequal();
              tr.b.soequal();
              tr.c.soequal();
              tr.a.soeqNorm();
              tr.b.soeqNorm();
              tr.c.soeqNorm();
              tr.soequal();
          }
      }
      else if(mode==10){
          n.unit();
          n.translate(-centerX, -centerY, -centerZ);
          n.scale(exs, eys, ezs);
          n.translate(centerX, centerY, centerZ);
          for(int i=0;i<sel2.size();i++){
              Triangle tr=(Triangle)sel2.elementAt(i);
              tr.setVertexMatrix(n);
              tr.setMatrix(n);
          }
          for(int i=0;i<sel2.size();i++){
              Triangle tr=(Triangle)sel2.elementAt(i);
              tr.a.soequal();
              tr.b.soequal();
              tr.c.soequal();
              tr.a.soeqNorm();
              tr.b.soeqNorm();
              tr.c.soeqNorm();
              tr.soequal();
              double length = Math.sqrt(tr.nx * tr.nx + tr.ny * tr.ny + tr.nz * tr.nz);
    tr.nx = (float)(tr.nx / ((length == 0D) ? 1D : length));
    tr.ny = (float)(tr.ny / ((length == 0D) ? 1D : length));
    tr.nz = (float)(tr.nz / ((length == 0D) ? 1D : length));
          }
      }
  }
  
  public void soequalVer(){
      act=0;
      if(mode==8){
      for(int i=0;i<sel3.size();i++){
              Vertex ver=(Vertex)sel3.elementAt(i);
              ver.move(ex0,ey0,ez0);
          }
      }
      else if(mode==9){
          n.unit();
          n.translate(-centerX, -centerY, -centerZ);
          n.yrot(ey);
          n.xrot(ex);
          n.zrot(ez);
          n.translate(centerX, centerY, centerZ);
          for(int i=0;i<sel3.size();i++){
              Vertex ver=(Vertex)sel3.elementAt(i);
              ver.setMatrix(n);
              ver.soequal();
              ver.soeqNorm();
          }
      }
      else if(mode==10){
          n.unit();
          n.translate(-centerX, -centerY, -centerZ);
          n.scale(exs, eys, ezs);
          n.translate(centerX, centerY, centerZ);
          for(int i=0;i<sel3.size();i++){
              Vertex ver=(Vertex)sel3.elementAt(i);
              ver.setMatrix(n);
              ver.soequal();
              ver.soeqNorm();
              ver.normalize();
          }
      }
  }
  
  //метод назад
    private void back() {
        resetTimer();
    if(mode==0&&in==POLY&&act>0){act=0;
        if(!gr.f.isEmpty()){
    m.g.addElement(gr);
    gr.countBoundary();
    sel=null;
    System.gc();
    sel=new Vector();
    sel.addElement(gr);
    centerX=gr.ax;
    centerY=gr.ay;
    centerZ=gr.az;
    }
    gr=null;
    System.gc();
    }
    else if(mode>=8&&act==1){modem=5;act=0;render();draw();}
    else Main.main.toMenu();
     }
    
    //при нажатии на 5 или джой.
    private void fire(){
        resetTimer();
        if(in==POLY){
            if(act==0){
                gr=new Group(null,"Object",m.g.size());
            act=2;
          if(Statics.randColor)color=(new Random()).nextInt(0xffffff);
            ver1=new Vertex(cur);
            }
            else if(act==1){
                act=2;
          if(Statics.randColor)color=(new Random()).nextInt(0xffffff);
                ver1=new Vertex(cur);
            }
            else if(act==2){
                act=3;
                ver2=new Vertex(cur);
            }
            else if(act==3){
                act=1;
                Triangle tr=new Triangle(new Vertex(ver1),new Vertex(ver2),new Vertex(cur),color);
                tr.norm();
                tr.smooth=false;
                tr.setMatrix(n);
                if(tr.rnz>0){tr.nz*=-1;tr.nx*=-1;tr.ny*=-1;}
                gr.add(tr);
    }
            return;
            }
        
        act++;
        if(act>1)act=0;
          if (act == 1){ ver1 = new Vertex(cur);
          if(Statics.randColor)color=(new Random()).nextInt(0xffffff);
          }
    if (act == 0 && in != OMNILIGHT) {
      if (in == BOX){m.add(Create.box(ver1,cur, color),"box");
//      Group la=m.getLast();
//      la.countBoundary();
      }
      else if (in == TORUS){ m.add(Create.torus(ver1, (int)Math.sqrt((cur.x - ver1.x) * (cur.x - ver1.x) + (cur.z - ver1.z) * (cur.z - ver1.z)), (int)Math.sqrt((cur.y-ver1.y)*(cur.y-ver1.y)), 20, 10, color),"torus");
//      m.getLast().countBoundary();
      }
      else if (in == PYRAMIDE){ m.add(Create.pyramid(ver1, new Vertex(cur.x,ver1.y,cur.z), cur.y-ver1.y, color),"pyramid");
//      m.getLast().countBoundary();
      }
      else if (in == CYLINDER){ m.add(Create.cylinder(ver1,Math.sqrt((cur.x-ver1.x)*(cur.x-ver1.x)+(cur.z-ver1.z)*(cur.z-ver1.z)), cur.y-ver1.y, 30, color),"cylinder");}
      else if (in == CONE) m.add(Create.cone(ver1, Math.sqrt((cur.x-ver1.x)*(cur.x-ver1.x)+(cur.z-ver1.z)*(cur.z-ver1.z)), cur.y-ver1.y, 30, color),"cone");
      else if (in == SPHERE) m.add(Create.sphere(ver1, Math.sqrt((cur.x - ver1.x) * (cur.x - ver1.x) + (cur.z - ver1.z) * (cur.z - ver1.z)+(cur.y-ver1.y)*(cur.y-ver1.y)), 20, 20, color),"sphere");
      else if (in == DISK) m.add(Create.disk(ver1,Math.sqrt((cur.x-ver1.x)*(cur.x-ver1.x)+(cur.z-ver1.z)*(cur.z-ver1.z)), 30, color),"disk");
      else if (in == PLANE) m.add(Create.plane(ver1, cur, color),"plane");
      m.getLast().countBoundary();
      centerX=m.getLast().ax;
      centerY=m.getLast().ay;
      centerZ=m.getLast().az;
      sel=null;
      System.gc();
      sel=new Vector();
      sel.addElement(m.getLast());
//      cur.y = 0;
    }
    if(in==OMNILIGHT){
        if(m.l==null){
            m.l=new Vector();
        }
        m.l.addElement(new Light(cur));
        act=0;
        sel=new Vector();
        sel.addElement(m.l.lastElement());
        System.gc();
    }
        
    }
  
}