// Главное меню программы.

import javax.microedition.io.*;
import javax.microedition.io.file.FileConnection;
import javax.microedition.lcdui.*;
import java.io.*;

public class MainMenu extends Canvas implements CommandListener
{
  Menu menu;
  int m,w,h;
  int sh = Statics.font.getHeight();
  String title;

  public MainMenu()
  {
    setFullScreenMode(true); 
    menu = new Menu(null, Statics.font);
    Statics.w=w=getWidth();
    Statics.h=h=getHeight();
    Statics.pers=(int)(w*1.25);
    menu.curColor = 0xcccccc;
    menu.textColor=Statics.menuTextColor;
    menu.selTextColor=Statics.menuTextColor;
  }

  void toMenu() {
    if(Main.main.e==null) menu.setElems(new String[] { Statics.russian?"Файл":"File", Statics.russian?"Настройки":"Settings", Statics.russian?"Дополнительно":"Extra"});
    else menu.setElems(new String[] {Statics.russian?"Файл":"File", Statics.russian?"Настройки":"Settings", Statics.russian?"Дополнительно":"Extra", Statics.russian?"Визуализировать":"Render"});
    title = Statics.russian?"Меню":"Menu";
    m = 0; }

  void toFile() {
    menu.setElems(new String[] { Statics.russian?"Новый":"New", Statics.russian?"Открыть":"Open", Statics.russian?"Сохранить":"Save", Statics.russian?"Справка":"Help", Statics.russian?"Инфо":"About", Statics.russian?"Выход":"Exit" });
    title = Statics.russian?"Файл":"File";
    m = 1; }

  void toSet() {
    menu.setElems(new String[] { Statics.russian?"Общие":"General", Statics.russian?"Цвета":"Color scheme", Statics.russian?"Сброс":"Full reset"});
    title = Statics.russian?"Настройки":"Settings";
    m = 2; }

  void toColors() {
    menu.setElems(new String[] { Statics.russian?"Фон редактора":"Editor field", Statics.russian?"Курсор":"Cursor", Statics.russian?"Сетка":"Grid", Statics.russian?"Фон меню":"Menu background", Statics.russian?"Текст":"Text", Statics.russian?"Эл-ты меню":"Menu items",Statics.russian?"Фон рендера":"Render background"});
    title = Statics.russian?"Цвета":"Color scheme";
    m = 3; }

  void toDop() {
    if(Main.main.e==null) menu.setElems(new String[] {Statics.russian?"Примеры":"Examples"});
    else menu.setElems(new String[] {Statics.russian?"Примеры":"Examples",Statics.russian?"Сброс вида":"Reset view",Statics.russian?"Описание":"Description"});
    title = Statics.russian?"Дополнительно":"Extra";
    m = 4; }

  void toExamples() {
    menu.setElems(new String[] {Statics.russian?"Кубы":"Cubes",Statics.russian?"Домик":"Home",Statics.russian?"Танк":"Tank",Statics.russian?"Логотип":"Logo"});
    title = Statics.russian?"Примеры":"Examples";
    m = 5;
  }
  void toSettings(){
      Form set=new Form(Statics.russian?"Настройки":"General Settings");
      Main.main.d.setCurrent(set);
      final ChoiceGroup sett=new ChoiceGroup("",List.MULTIPLE);
      sett.append(Statics.russian?"Сетка":"Grid",null);
      sett.append(Statics.russian?"Вспомогательные буферы":"Extra Buffers",null);
      sett.append(Statics.russian?"Сенсорный ввод":"Touch Input",null);
      sett.append(Statics.russian?"Крупные иконки":"Big Icons",null);
      sett.append(Statics.russian?"Случайный цвет новых объектов":"Random Color of new objects",null);
      sett.setSelectedFlags(new boolean[]{Statics.grid,Statics.extraBuffers,Statics.touch,Statics.bigImages,Statics.randColor});
      set.append(sett);
      final TextField lim=new TextField(Statics.russian?"Дальность отрисовки":"Visible distance",""+Statics.limit,10,TextField.NUMERIC);
      final TextField per=new TextField(Statics.russian?"Перспектива":"Perspective",""+Statics.pers,10,TextField.NUMERIC);
      set.append(lim);
      set.append(per);
      final ChoiceGroup tex=new ChoiceGroup(Statics.russian?"Сжатие текстур":"Texture compression",List.EXCLUSIVE);
      tex.append("Png", null);
      tex.append("Jpg", null);
      tex.append(Statics.russian?"Без потерь(большой размер файла)":"Lossless(huge file size)", null);
      tex.append("Gif(256 colors)", null);
      tex.setSelectedIndex(Statics.textureSaving, true);
      set.append(tex);
      final ChoiceGroup fontc=new ChoiceGroup(Statics.russian?"Шрифт":"Font size",List.EXCLUSIVE);
      fontc.append(Statics.russian?"Мелкий":"Small", null);
      fontc.append(Statics.russian?"Средний":"Medium",null);
      fontc.append(Statics.russian?"Крупный":"Large",null);
      int ii=Statics.font.getSize();
      if(ii==Font.SIZE_SMALL)fontc.setSelectedIndex(0, true);
      else if(ii==Font.SIZE_MEDIUM)fontc.setSelectedIndex(1, true);
      else fontc.setSelectedIndex(2, true);
      set.append(fontc);
      final ChoiceGroup lang=new ChoiceGroup(Statics.russian?"Язык":"Language",List.EXCLUSIVE);
      lang.append("Русский", null);
      lang.append("English",null);
      lang.setSelectedIndex(Statics.russian?0:1,true);
      set.append(lang);
      set.addCommand(new Command("Ok",Command.OK,1));
      set.setCommandListener(new CommandListener(){
      public void commandAction(Command c,Displayable d){
          int met;
          if(fontc.getSelectedIndex()==0)met=Font.SIZE_SMALL;
          else if(fontc.getSelectedIndex()==1)met=Font.SIZE_MEDIUM;
          else met=Font.SIZE_LARGE;
          Statics.font=Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD, met);
          Statics.russian=lang.getSelectedIndex()==0;
          Statics.limit=Integer.parseInt(lim.getString());
          Statics.pers=Integer.parseInt(per.getString());
          Statics.textureSaving=tex.getSelectedIndex();
          boolean[] ba=new boolean[5];
          sett.getSelectedFlags(ba);
          Statics.grid=ba[0];
          Statics.extraBuffers=ba[1];
          Statics.touch=ba[2];
          Statics.bigImages=ba[3];
          Statics.randColor=ba[4];
      Main.main.d.setCurrent(Main.main.menu);
      }
      });
  }

  public void paint(Graphics g)
  {
      if(m==6){
          g.drawRGB(Main.main.e.rgb, 0, w, 0, 0,  w,h, false);
          drawLeftSoft(g,Statics.russian?"Сохранить":"Save");
          drawRightSoft(g,">");
          repaint();
          return;
                  }
    g.setColor(Statics.menuBack);
    g.fillRect(0, 0, w, h);
    menu.paint(g, 0, h/3, w, h, 1);
    //drawBorders(g);
    g.setColor(Statics.textColor);
    g.drawString(title, w / 2, 0, 17);
    drawLeftSoft(g,Statics.russian?"Выбор":"Select");
    if ((Main.main.e != null) || (m > 0))
      drawRightSoft(g,Statics.russian?"Назад":"Back");
  }

  public void drawBorders(Graphics g) {
    g.setColor(8947967);
    g.fillRect(0, 0, w, sh / 2);
    g.fillRect(0, h - sh + 1, w, sh / 2);
    g.setColor(7632107);
    g.fillRect(0, h - sh / 2 + 1, w, sh / 2);
    g.fillRect(0, sh / 2, w, sh / 2);
  }
  
          private void drawLeftSoft(Graphics g,String s){
        int sh=g.getFont().getHeight();
        if(!Statics.touch){
        g.setColor(8947967);
        g.fillRoundRect(0, h - sh+1, g.getFont().stringWidth(s)+5, sh-1,10,10);
        g.setColor(0);
        g.drawRoundRect(0, h - sh+1, g.getFont().stringWidth(s)+5, sh-2,10,10);
        g.setColor(0x555555);
        g.drawString(s, 2, h - 2, 36);
        g.setColor(Statics.textColor);
        g.drawString(s, 3, h - 1, 36);}
        else{
            g.setColor(8947967);
        g.fillRoundRect(0, h - 40, g.getFont().stringWidth(s)+5, 39,15,15);
        g.setColor(0);
        g.drawRoundRect(0, h - 40, g.getFont().stringWidth(s)+5, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, 2, h + sh/2 - 20, 36);
        g.setColor(Statics.textColor);
        g.drawString(s, 3, h +sh/2 - 19, 36);
        }
    }
    
    private void drawRightSoft(Graphics g,String s){
        int sh=g.getFont().getHeight();
        if(!Statics.touch){
        g.setColor(8947967);
        g.fillRoundRect(w-g.getFont().stringWidth(s)-5, h - sh + 1, g.getFont().stringWidth(s)+5, sh-1,10,10);
        g.setColor(0);
        g.drawRoundRect(w-g.getFont().stringWidth(s)-5, h - sh + 1, g.getFont().stringWidth(s)+4, sh-2,10,10);
        g.setColor(0x555555);
        g.drawString(s, w - 4, h - 2, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, w - 3, h - 1, 40);}
        else{
            g.setColor(8947967);
            g.fillRoundRect(w-g.getFont().stringWidth(s)-5, h - 40, g.getFont().stringWidth(s)+5, 39,15,15);
            g.setColor(0);
        g.drawRoundRect(w-g.getFont().stringWidth(s)-5, h-40, g.getFont().stringWidth(s)+4, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, w - 4, h+sh/2- 20, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, w - 3, h+sh/2 - 19, 40);
        }
    }

  protected void keyPressed(int keyCode)
  {
    int g = getGameAction(keyCode);
    if (g == 1) {
      menu.up();
    } else if (g == 6) {
      menu.down();
    } else if (g == 8) {
      fire();
    } else {
      String strCode = null;
      try {
        strCode = getKeyName(keyCode).toLowerCase();
      }
      catch (IllegalArgumentException e) {
      }
      if (strCode != null)
      {
        if (("soft1".equals(strCode)) || ("soft 1".equals(strCode)) || ("soft_1".equals(strCode)) || ("softkey 1".equals(strCode)) || ("sk2(left)".equals(strCode)) || (strCode.startsWith("left soft"))){
          fire(); return; }
        if (("soft2".equals(strCode)) || ("soft 2".equals(strCode)) || ("soft_2".equals(strCode)) || ("softkey 4".equals(strCode)) || ("sk1(right)".equals(strCode)) || (strCode.startsWith("right soft"))){
          back(); return;}
      }
      switch (keyCode)
      {
      case -202:
      case -21:
      case -6:
      case 21:
      case 105:
      case 113:
      case 57345:
        fire(); break;
      case -203:
      case -22:
      case -7:
      case 22:
      case 106:
      case 112:
      case 57346:
        back(); break;
      }
    }
    repaint(); }

  public void fire() {
    switch (m) {
    case 0:
      switch (menu.index) {
      case 0:
        toFile(); break;
      case 1:
        toSet(); break;
      case 2:
        toDop();break;
      case 3: render();break;}
      break;
    case 1:
      switch (menu.index) {
      case 0:
        newModel(); break;
      case 1:
        open(); break;
      case 2:
        save(); break;
      case 3:
        help(); break;
      case 4:
        info(); break;
      case 5:
        exit(); }
      break;
    case 2:
      switch (menu.index)
      {
      case 0:
        toSettings();break;
      case 1:
        toColors(); break;
      case 2: Main.main.fullReset(); break;
      }
      break;
    case 4:
      switch (menu.index) {
      case 0:
        toExamples();break;
      case 1: Main.main.resetView();break;
      case 2: desc();
      } break;
    case 3: Main.main.setColor(menu.index+1); break;
    case 5: switch(menu.index){
        case 0: loadExample("/examples/cubes.s3d"); break;
        case 1: loadExample("/examples/home.s3d"); break;
        case 2: loadExample("/examples/tank.s3d"); break;
        case 3: loadExample("/examples/logo.s3d"); break;
    } break;
    case 6: Main.main.toSaveRender();
    }
    repaint();
  }
  
  private void loadExample(String s){
          Main.main.newEditor();
          System.gc();
          Loader l=new Loader();
          if(s.endsWith(".obj"))
              Main.main.e.m=l.loadObj(getClass().getResourceAsStream(s));
          else Main.main.e.m=l.loadResourceAsS3D(s);
          Main.main.toEditor();
  }
  
  private void render(){
      m=6;
      Editor e=Main.main.e;
      for(int i=0;i<e.rgb.length;i++){
          e.rgb[i]=Statics.background;
          e.zb[i]=Integer.MAX_VALUE;
      }
      e.m.render(e.rgb, e.zb, e.n,1,0);
  }

  public void back() {
    switch (m) {
    case 0:
      Main.main.toEditor(); break;
    case 1:
    case 2:
    case 6:
    case 4:
      toMenu(); break;
    case 3:
      toSet(); break;
    case 5:
      toDop();break;
    }
    repaint();
  }

  public void newModel() {
    Main.main.newEditor();
    Main.main.toEditor();
  }

  public void open()
  {
 /*     final TextBox tb=new TextBox("opening","E:/file.wax",1000,0);
      tb.addCommand(new Command("Ok",Command.OK,1));
      Main.main.d.setCurrent(tb);
      tb.setCommandListener(new CommandListener() {
          public void commandAction(Command c,Displayable dis){
      Main.main.newEditor();
      Loader l=new Loader();
      try{
            FileConnection fc=(FileConnection)Connector.open("file:///"+tb.getString(),Connector.READ);
            if(!fc.exists()){Main.main.toEditor();l=null; }
      if(tb.getString().endsWith(".wax"))
          Main.main.e.m=l.openWax(fc.openInputStream());
      else if(tb.getString().endsWith(".obj"))
          Main.main.e.m=l.loadObj(fc.openInputStream());
      l=null;
      Main.main.toEditor();
      }catch(Exception e){l=null; Main.main.toEditor();}
          }
      });*/
      Main.main.toOpen();
  }
  
  public void open(String path){
      Main.main.newEditor();
      Loader l=new Loader();
      try{
            FileConnection fc=(FileConnection)Connector.open("file://"+path,Connector.READ);
            if(!fc.exists()){Main.main.toEditor();l=null; }
            InputStream is=fc.openInputStream();
      if(path.endsWith(".wax"))
          Main.main.e.m=l.openWax(is);
      else if(path.endsWith(".obj"))
          Main.main.e.m=l.loadObj(is);
      else if(path.endsWith(".s3d"))
          Main.main.e.m=l.loadS3D(is);
      l=null;
      is.close();
      fc.close();
      //Main.main.toEditor();
      }catch(Exception e){l=null;}
      Main.main.toEditor();
  }

  public void save()
  {
      Main.main.toSave();
  }
  public void save(String path){
      try{
          FileConnection fc=(FileConnection)Connector.open("file://"+path,Connector.READ_WRITE);
          if(fc.exists())
              fc.delete();
          fc.create();
          OutputStream os=fc.openOutputStream();
          Saver.saveS3D(Main.main.e.m, MaterialEditor.mat, os);
          os.close();
      }catch(Exception e){}
          Main.main.toEditor();
  }
  
  Form help;
  List lst;

  public void help()
  {
      help=new Form("");
      lst=new List(Statics.russian?"Справка":"Help",List.IMPLICIT,new String[]{Statics.russian?"Общее":"Common",Statics.russian?"Окно редактора":"Workspace",Statics.russian?"Меню редактирования":"Edit menu",Statics.russian?"Цвет и материалы":"Colors and materials"},null);
      Main.main.d.setCurrent(lst);
      lst.setCommandListener(this);
      help.setCommandListener(this);
      Command c=new Command("Ok",Command.OK,1);
      lst.addCommand(c);
      help.addCommand(c);
      lst.addCommand(new Command(Statics.russian?"Назад":"Back",Command.BACK,2));
  }

  public void info()
  {
      help=new Form(Statics.russian?"Инфо":"About");
      if(Statics.russian)help.append("S3D Editor. Версия 0.6. Java-программа на мобильные телефоны для 3д-моделирования и творчества. В принципе, можно использовать и для 3д игр на телефон, однако это невозможно без моей java-библиотеки(движка), которую я выпущу чуть позже, а экпортировать в m3g пока нет возможности (но я работаю над этим). Все пожелания, вопросы, просьбы опять же сюда:\n e-mail: shaman_c75@mail.ru\n http://vk.com/shamanner \n http://shamansite.wen.ru \nмистер Shaman. Две тысячи тринадцатый год :)");
      else help.append("S3D Editor. Version 0.6. Java-application on mobile phones for 3d-modeling and art. When java-library will be released, it will possible to develop 3d-games using this editor. I'm trying to add opportunity to import and export m3g-scenes. All questions and wishes sent there:\n e-mail: shaman_c75@mail.ru\n http://vk.com/shamanner \n http://shamansite.wen.ru \n mister Shaman, Two thousand and thirteenth :)");
      help.addCommand(new Command("Ok",Command.BACK,2));
      help.setCommandListener(this);
      Main.main.d.setCurrent(help);
  }
  
  public void commandAction(Command com,Displayable dis){
      if(com.getPriority()==2)Main.main.d.setCurrent(this);
      else if(com.getPriority()==1||com==List.SELECT_COMMAND){
          if(dis==help)Main.main.d.setCurrent(lst);
          else{
                  help.deleteAll();
              switch(lst.getSelectedIndex()){
              case 0: help.setTitle(Statics.russian?"Общее":"Common");
                  if(Statics.russian)help.append("Общее описание.\n\nS3D Editor - 3D рисовалка для мобильного телефона. Есть возможность загружать модели формата *.obj, *.wax (мобильное приложение 3d studio wax), а также сохранять и загружать в собственный формат проекта *.s3d. Приложение позволяет создавать основные стереометрические примитивы и использовать полигональное моделирование, настраивать материалы для каждого полигона (текстура, прозрачность, самосвечение и т.д.), добавлять несколько точечных источников света (пока только белого цвета и фиксированной мощности) и рендерить это все в изображение.\n Также каждая модель имеет собственное название, создателя и описание, которые можно найти в главном меню в \"Дополнительно - Описание\".");
                  else help.append("Common description. \n\n S3D Editor - 3D paint on mobile phone. There is an opportunity to load *.obj, *.wax(mobile application 3d studio wax) and to save projects into *.s3d. Program allows to create volume figures consisting of basic stereometric primitives and manually built polygon meshes, set up material for every polygon(texture map,opacity,self illumination,etc.), add sources of lighting(now only white color and fixed capacity) and render it into image. Also every model has its name, vendor and description, that you can find in menu \"Extra - Description\"");
                  break;
              case 1: help.setTitle(Statics.russian?"Окно редактора":"Workspace");
                  if(Statics.russian)help.append("Рабочее пространство представляет из себя открытое место, опциональную сетку, сверху - иконки инструментов и текущий цвет (изначально белый), снизу иконка режима. Нажав на нее(или нажав клавишу 0), откроется подменю выбора режима, которое меняется нажатиями вверх-вниз. В этом меню вы найдете режимы добавления объекта,обзора,движения,увеличения, выделения и изменения выбранных объектов.\n Поподробнее:\n Первые 4 режима уже названы - добавление, обзор, движение и масштаб. Вторые 4 режима - работа с выделением: единичный выбор (зажав звездочку или на сенсоре нажав кнопку \"Добавить\", можно выделить несколько объектов), выделение рамкой, выделение 3d-кубом и список объектов. Последние 3 режима - это сдвиг, поворот и масштабирование выделения, т.е. преобразования объектов. Ели жазать звездочку (или нажать кнопку \"Дубликат\") и нажать Ок, то измененные объекты будут копированы, сколько хочется раз.\n\n Другие возможности: \n Чтобы открыть список инструментов, нажмите левый софткей (на сенсорнике - иконка справа вверху с изображением текущего инструмента), меню редактирования - по клавише 9 (на сенсорном кнопка внизу \"Редакт\"), клавиша 7 откроет подменю типа отрисовки и обзора (или на экране нажать в левом верхнем углу), клавиша * открывает настройщик цвета, если ее зажать - откроется редактор материалов (аналогично - на экране с цветным квадратом).");
                  else help.append("Workspace is main window of modeling. There is optional grid, tools icon and current color(default white) upper center and mode icon on the bottom. Press on it (or press key 0) and opens mode submenu (it changes with up-down). That menu contains 11 modes of work. First 4 modes is new object,preview,move and scale view. Next 4 modes is for selection. You can pick up object (button \"add\" or pressed keystar allows picking up a few objects), select via rect and 3d-box and select via list. The last four modes is transform objects: move,rotate and scale. If pressed keystar or button \"Duplicate\", selection will be copied several times. Other buttons:\n if you press key 7 or the upper left corner of screen shading and view menu opens, key 9 or button \"Edit\" opens edition menu, tool icon in the upper right corner - list of tools,key star leads to settings of color and help key star opens material editor (for touch screen analogically with color square near the tool icon).");
                  break;
              case 2: help.setTitle(Statics.russian?"Меню редактирования":"Edit menu");
                  if(Statics.russian)help.append("Меню редактирования нужно для более обширного редактирования. Сверху есть три иконки, обозначающие уровень изменения: объекты, полигоны, вершины. Т.е. если выбрать (<>) уровень полигонов и нажать назад, то в рабочем окне вы сможете выделять и взаимодействовать с полигонами и т.д. Теперь о пунктах меню:\n - Свойства. Свойства выделенного объекта (работает только если выбран один объект). Можно менять имя объекта, его видимость, узнать информацию об объекте.\n UV-координаты. Настройка текстурных координат для выбранных полигонов (на выбранном уровне полигонов разумеется). Как известно, у каждой вершины треугольника для текстурирования есть текстурные координаты, их и можно редактировать. так же клавишами * и # можно выбрать текстуру из доступных материалов для наглядного редактирования.\n Нормали. Это перпендикуляры к полигонам и вершинам, нужны в основном для освещения. Их можно обратить (перевернуть) и перерасчитать для выбранных объектов на соответствующем уровне. Не советую без необходимости перерасчитывать нормали для полигонов и объектов, т.к. чаще всего это будет неправильно и для многих треугольников придется вручную обращать нормали.\n Сглаживание. Применяется для объектов и полигонов. Включает или выключает сглаживание между полигонами наподобие групп сглаживания в 3d studio max, но здесь только две группы - сглаживание и плоское освещение.\n - Пробный материал. Назначает тестовый материал на все объекты и добавляется в список в редакторе материалов. Просто так.\n - Удалить материал. С выбранных объектов или полигонов.\n - Удалить. удаляет выбранные объекты/полигоны/вершины.\n - Отделить. Отделяет выбранные полигоны в отдельный объект.");
                  help.append("Edition menu is for more wide edition. Three icons define the edition level: objects, polygons and vertexes. That means if you choose (<>) polygon level in workspace you are able to select and transform only triangles in scene. Now about menu itms:\n - Properties. Properties of selected object(is available if only one object is selected) show its name, visibility,info.\n UVs - texture coordinates for selected triangles(of course, on the polygon level). Every vertex has uv coordinates according to its position on flat texture. Use * and # to change background image from available scene material.\n - Normals. It's a perpendicular for triangle. Is necessary for lighting. You can invert and recalculate it for any objects, but I don't advise to recalculate normals for objects and triangles without need because it will be incorrect and you will have to invert them manually.\n - Smooth. Turns on and off smoothing between polygons. Like smoothing groups in 3ds max but much easier.\n - Test material. Applies test material to the all objects. Just like that.\n - Delete material. Deletes material in selected polygons or objects. \n - Delete. Objects/triangles/vertexes.\n - Detach. Separates selected polygons into single object.");
                  break;
              case 3: help.setTitle(Statics.russian?"Цвет и материалы":"Colors and materials");
                  if(Statics.russian)help.append("Нажав звездочку или квадрат цвета в рабочем пространстве открывает настройка цвета. Можно вручную подобрать цвет по RGB или же найти его в палитре. Соответственно, если зажать звездочку или цветной квадрат, открывается Редактор материалов. Изначально там список материалов в сцене. Если выбрать любой, можно увидеть настройки для материала. По порядку: название, непрозрачность, самосвечение, масштабирование по U и V (горизонтально и вертикально) и сдвиг по U и V(это для текстуры), цвет, текстурная карта, двухсторонняя видимость и бесцветность(т.е. независимо от текстуры или цвета материала, полигон с этим материалом будет иметь цвет, который был ему задан при создании).");
                  else help.append("Press * or color square in workspace and you will see setteing of color. You're able to set it manually using RGB or find color in palette. If you hold the same buttons, material editor opens. Here you may find list of materials in scene and settings for every material. In order:\n name, opacity, self illumination, scaling and offset of texture along U and V, diffuse color, texture map, double-sided visibility and colorless (independently from used color or texture, triangle draws with color which was given while creation).");
                  break;
          }
              Main.main.d.setCurrent(help);
          }
      }
  }
  
  public void desc(){
      final Form f=new Form(Statics.russian?"Описание":"Scene descriptor");
      final TextField nm=new TextField(Statics.russian?"Название:":"Name",Main.main.e.name,30,TextField.ANY),vn=new TextField(Statics.russian?"Создатель:":"Creator",Main.main.e.vendor,30,TextField.ANY),desc=new TextField(Statics.russian?"Описание:":"Description",Main.main.e.description,30,TextField.ANY);
      f.append(""+Main.main.e.m.g.size()+(Statics.russian?" объектов":"objects"));
      int fin=0,vin=0;
      for(int i=0;i<Main.main.e.m.g.size();i++){
          Group gr=(Group)Main.main.e.m.g.elementAt(i);
          fin+=gr.f.size();
          vin+=gr.v.size();
      }
      f.append(""+fin+(Statics.russian?" полигонов":"triangles"));
      f.append(""+vin+(Statics.russian?" вершин":"vertexes"));
      f.append(nm);
      f.append(vn);
      f.append(desc);
      f.append((Statics.russian?"Свободно памяти":"Free heap:")+Runtime.getRuntime().freeMemory());
      f.addCommand(new Command("Ok",1,1));
      f.addCommand(new Command(Statics.russian?"Сборка мусора":"Collect garbage",Command.HELP,2));
      Main.main.d.setCurrent(f);
      f.setCommandListener(new CommandListener(){
      public void commandAction(Command c,Displayable dis){
          if(c.getPriority()==1){
          Main.main.e.name=nm.getString();
          Main.main.e.vendor=vn.getString();
          Main.main.e.description=desc.getString();
      Main.main.toMenu();
          }
          else{
              System.gc();
              f.delete(6);
              f.append((Statics.russian?"Свободно памяти":"Free heap:")+Runtime.getRuntime().freeMemory());
          }
      }
      });
  }

  public void exit() {
    Main.main.destroyApp(true);
  }

  protected void keyReleased(int keyCode)
  {
  }

  protected void keyRepeated(int keyCode)
  {
  }

  protected void pointerDragged(int x, int y)
  {
    int t = menu.getTouchIndex(y);
    if (t != 16777215)
      menu.index = t;

    repaint();
  }

  protected void pointerPressed(int xp, int yp)
  {
      if(yp>=h-40){
          if(xp<=w/4){
              fire();
          }
          else if(xp>=w-w/4)back();
      }
    int t = menu.getTouchIndex(yp);
    if (t != 16777215)
      menu.index = t;
    repaint();
  }

  protected void pointerReleased(int x, int y)
  {
    int t = menu.getTouchIndex(y);
    if (t != 16777215) {
      menu.index = t;
      fire();
    }
    repaint();
  }
}